VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Custom_ICN"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Custom icons from XavSnap.

Option Explicit

Public m_TipText As String             'text to be displayed on icon
Public m_Fore_Color As Long
Public m_Shadow_Color As Long

' Text functions:
Private Declare Function DrawText Lib "user32.dll" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
    Private Const DT_BOTTOM = &H8
    Private Const DT_CENTER = &H1
    Private Const DT_LEFT = &H0
    Private Const DT_CALCRECT = &H400
    Private Const DT_WORDBREAK = &H10
    Private Const DT_VCENTER = &H4
    Private Const DT_TOP = &H0
    Private Const DT_TABSTOP = &H80
    Private Const DT_SINGLELINE = &H20
    Private Const DT_RIGHT = &H2
    Private Const DT_NOCLIP = &H100
    Private Const DT_INTERNAL = &H1000
    Private Const DT_EXTERNALLEADING = &H200
    Private Const DT_EXPANDTABS = &H40
    Private Const DT_CHARSTREAM = 4
    Private Const DT_NOPREFIX = &H800
    Private Const DT_EDITCONTROL = &H2000&
    Private Const DT_PATH_ELLIPSIS = &H4000&
    Private Const DT_END_ELLIPSIS = &H8000&
    Private Const DT_MODIFYSTRING = &H10000
    Private Const DT_RTLREADING = &H20000
    Private Const DT_WORD_ELLIPSIS = &H40000


Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type
   


Public Function paint(Def_picture As Object, Result_icon As Object)

Dim tR As RECT
Dim lhDC As Long
 
With Result_icon
 
  .BackColor = Result_icon.BackColor
  .FontSize = 6
  .FontBold = True
  .FontName = "terminal"
  .Picture = Def_picture.Picture
  .AutoRedraw = True
End With

 lhDC = Result_icon.hdc
 
'Draw Shadow
      Result_icon.ForeColor = m_Shadow_Color
      tR.Left = 1: tR.Top = 1: tR.Right = 16: tR.Bottom = 8
      DrawText lhDC, Left(m_TipText, 2), -1, tR, DT_CENTER Or DT_VCENTER Or DT_SINGLELINE Or DT_END_ELLIPSIS

'Draw text
      Result_icon.ForeColor = m_Fore_Color
      tR.Left = 0: tR.Top = 0: tR.Right = 15: tR.Bottom = 7
      DrawText lhDC, Left(m_TipText, 2), -1, tR, DT_CENTER Or DT_VCENTER Or DT_SINGLELINE Or DT_END_ELLIPSIS

If Len(m_TipText) > 2 Then

'Draw Shadow
      Result_icon.ForeColor = m_Shadow_Color
      tR.Left = 1: tR.Top = 8: tR.Right = 16: tR.Bottom = 15
      DrawText lhDC, Mid(m_TipText, 3, Len(m_TipText)), -1, tR, DT_CENTER Or DT_VCENTER Or DT_SINGLELINE Or DT_END_ELLIPSIS
      
      tR.Left = -1: tR.Top = 8: tR.Right = 14: tR.Bottom = 15
      DrawText lhDC, Mid(m_TipText, 3, Len(m_TipText)), -1, tR, DT_CENTER Or DT_VCENTER Or DT_SINGLELINE Or DT_END_ELLIPSIS

'Draw text
      Result_icon.ForeColor = m_Fore_Color
      tR.Left = 0: tR.Top = 8: tR.Right = 15: tR.Bottom = 15
      DrawText lhDC, Mid(m_TipText, 3, Len(m_TipText)), -1, tR, DT_CENTER Or DT_VCENTER Or DT_SINGLELINE Or DT_END_ELLIPSIS

End If

End Function

