Attribute VB_Name = "Info_Roms"
Option Explicit



' INFO ROMs

' Check  system compatibilty :


  Public Sub os_info_ROM(Nom_fichier As String, Tag As String)
 
 Select Case Tag
'Nintendo GameBoy
'Nintendo Super GameBoy
'Nintendo GameBoy Pocket
'Nintendo GameBoy Color

Case "GB"
' Game Boy.
  DskCenter.info_dsk_1.text = " GameBoy Rom." & vbCrLf
  DskCenter.Info_dos_header.Visible = True
  Get_GB_infos (Nom_fichier)
  
Case "GBC"
' Game Boy Color.
  DskCenter.info_dsk_1.text = " GameBoy Color Rom." & vbCrLf
  DskCenter.Info_dos_header.Visible = True
  Get_GB_infos (Nom_fichier)
  
Case "NES24"
' NES - Nintendo -24K-.
  DskCenter.info_dsk_1.text = " Famicom-NES Rom 24Kb." & vbCrLf

Case "NES128"
' NES - Nintendo -128K-.
  DskCenter.info_dsk_1.text = " Famicom-NES Rom 128Kb." & vbCrLf

Case "NESDSK"
' NES - Nintendo with floppy disk.
  DskCenter.info_dsk_1.text = " Famicom-NES Disk Device." & vbCrLf
 
Case "SMC"
' Super Nintendo(SNES).
 DskCenter.info_dsk_1.text = "Super Nintendo Rom[SNES]" & vbCrLf
 DskCenter.Info_dos_header.Visible = True
 Get_SNES_infos (Nom_fichier)

Case "V64"
' Nintendo 64.
 DskCenter.info_dsk_1.text = " Nintendo 64 Rom." & vbCrLf
 
Case "SMS"
' Sega Master System.
 DskCenter.info_dsk_1.text = " Sega Master System Rom." & vbCrLf
 
Case "SMS!"
' Sega Master System.
 DskCenter.info_dsk_1.text = " Sega Master System Rom." & vbCrLf & " May be corrupt!" & vbCrLf
 
Case "GBA"
' Game Boy Advance.
 DskCenter.info_dsk_1.text = " Game Boy Advance Rom." & vbCrLf

Case "SG"
' SG-1000.
 DskCenter.info_dsk_1.text = " SG-1000 Rom." & vbCrLf
 
Case "GG"
' Game Gear.
 DskCenter.info_dsk_1.text = " Game Gear Rom." & vbCrLf
 
Case "ELF"
' PlayStation II.
 DskCenter.info_dsk_1.text = " PlayStation 2 Rom." & vbCrLf

Case "LYNX"
' Lynx.
 DskCenter.info_dsk_1.text = " Atari Lynx Rom." & vbCrLf
 
Case "A26"
' Atari 2600 (roms x2048b).
 DskCenter.info_dsk_1.text = " Atari 2600 Rom." & vbCrLf
 
Case "VEC"
' Vectrex (roms x2048b).
 DskCenter.info_dsk_1.text = " Vectrex Rom." & vbCrLf
  
Case "A78_32K"
' Atari 7800 32Kb.
 DskCenter.info_dsk_1.text = " Atari 7800 32Kb Rom." & vbCrLf

Case "A78_64K"
' Atari 7800 64kb.
 DskCenter.info_dsk_1.text = " Atari 7800 64Kb Rom." & vbCrLf

Case "GC-DOL"
' Game Cube ( Dol extension).
 DskCenter.info_dsk_1.text = " Game Cube DOL Format." & vbCrLf

Case "GC-ELF"
' Game Cube ( Elf extension).
 DskCenter.info_dsk_1.text = " Game Cube ELF Format." & vbCrLf

End Select
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & " Lenght: " & format(FileLen(Nom_fichier), "  ###### 000 000") & " Bytes" & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & " CRC32 [ " & Check_CRC32_file(Nom_fichier) & " ]"
 End Sub

