Attribute VB_Name = "Scan_Amiga_Dir"
Option Explicit

' Dir Scan functions
' Amiga DOS file list
Public Function Read_Cat_Amiga(fileName As String, Optional Dsk_sys_tag As String, Optional undelete As Boolean = False, Optional undel_name As String = "", Optional Ch_attrib As String = "", Optional Get_Property As Boolean = False, Optional Open_Frame As Boolean = True, Optional Folder_offset As Integer = 0, Optional Parent_Name As String = "ROOT", Optional Start_Offset As Single = 1029)
'If Cut_Name(FileName) = "" Then Exit Function

Dsk_LED (True)

Dim length As Single
Dim DirEntry As AMIGA_Dos_Cat
Dim attr_Tag As Double
Dim dos_release As Byte
Dim disk_info As Byte
Dim a As Integer
Dim actual_seek As Long  ' seek memory for multiple-blocs > 16 ko.
Dim seek_compter ' seek offset for multiple-blocs > 16 ko.
Dim total_blocs As Long
Dim Nb_Fichiers As Integer
Dim attr_str As String
Dim DIR_TAG As Byte
Dim attrib_bin As String

'init PC treeview.
DskCenter.ProDos_tree.Nodes.Clear
  
Set DskCenter.Info_image.Picture = DskCenter.ImageList_msk.ListImages("info_on").Picture

 liX = FreeFile

 Nb_Fichiers = 0 ' file index for multi-files blocs
 total_blocs = 0     ' Used memory bloc -> 1024 bytes per bloc
 
 Open fileName For Binary As #liX Len = Len(DirEntry)

' Pick-up disk type 3 bits : Fast System + Directory caching + International Mode.
Get #liX, 4, disk_info
 
' Pick-up AmogaDos Realease.
'Get #liX, 4, dos_release

Select Case dos_release
 Case 0
 DskCenter.Label_Directory.Caption = "Directory: Amiga Dos System."
 Case Else
 DskCenter.Label_Directory.Caption = "Directory: Amiga Dos V." & Val(dos_release)
End Select


  actual_seek = 450665
    'actual_seek = 450660
  DskCenter.ProDos_tree.Nodes.Add , , "F" & Nb_Fichiers, "A: ", ICN_Disk
  
  DskCenter.ProDos_tree.Nodes("F" & Nb_Fichiers).BackColor = &HA7A7A7
  DskCenter.ProDos_tree.Nodes("F" & Nb_Fichiers).Bold = True
  DskCenter.ProDos_tree.Nodes("F" & Nb_Fichiers).ForeColor = &HFFFFFF
 
' disk type 3 bits : Fast System + Directory caching + International Mode.

Nb_Fichiers = Nb_Fichiers + 1

If (disk_info And 7) = 0 Then
DskCenter.ProDos_tree.Nodes.Add , , "F" & Nb_Fichiers, " Standard disk."
Else
DskCenter.ProDos_tree.Nodes.Add , , "F" & Nb_Fichiers, " "
End If

 If (disk_info And 1) = 1 Then DskCenter.ProDos_tree.Nodes("F" & Nb_Fichiers).text = DskCenter.ProDos_tree.Nodes("F" & Nb_Fichiers).text + "FastSys"
 If (disk_info And 2) = 2 Then
 If DskCenter.ProDos_tree.Nodes("F" & Nb_Fichiers).text <> " " Then DskCenter.ProDos_tree.Nodes("F" & Nb_Fichiers).text = DskCenter.ProDos_tree.Nodes("F" & Nb_Fichiers).text + "\"
 DskCenter.ProDos_tree.Nodes("F" & Nb_Fichiers).text = DskCenter.ProDos_tree.Nodes("F" & Nb_Fichiers).text + "Intern.Mode"
 End If
 
 If (disk_info And 4) = 4 Then
 If DskCenter.ProDos_tree.Nodes("F" & Nb_Fichiers).text <> " " Then DskCenter.ProDos_tree.Nodes("F" & Nb_Fichiers).text = DskCenter.ProDos_tree.Nodes("F" & Nb_Fichiers).text + "\"
 DskCenter.ProDos_tree.Nodes("F" & Nb_Fichiers).text = DskCenter.ProDos_tree.Nodes("F" & Nb_Fichiers).text + "DirCache"
 End If

'******************************************************************************************
 
      Get #liX, actual_seek, DirEntry
      Dsk_LED (False)
      Debug.Print "length:"; Len(DirEntry)
      TmpChar = Left(DirEntry.Comment, DirEntry.commLen)

      DskCenter.ProDos_tree.Nodes.Item("F0").text = "Volume :" & TmpChar
      
      actual_seek = actual_seek + 1024
      Get #liX, actual_seek, DirEntry
      
     
      
  Do While Asc(Left(DirEntry.Comment, 1)) <> 0 Or DirEntry.commLen > 79
  
  If Mid(DirEntry.Comment, DirEntry.commLen + 1, 1) <> Chr(0) Then Exit Do
  
  Nb_Fichiers = Nb_Fichiers + 1
  
  Get #liX, actual_seek, DirEntry
  
  If Left(DirEntry.Comment, 1) = Chr(0) Then Exit Do
  'Or DirEntry.Dir_Entry <> &H17
  
  TmpChar = Left(DirEntry.Comment, DirEntry.commLen)
  

   
  DskCenter.ProDos_tree.Nodes.Add , , "F" & Nb_Fichiers, TmpChar, "Dir_file"
   
  
  attrib_bin = ConvBin(CDbl(Decode_str_hex(DirEntry.access)), 32)
  
' 0       Delete forbidden (D)
' 1       Not executable (E)
' 2       Not writable (W)
'                                                3       Not readable (R)
'                                                4       Is archived (A)
'                                                5       Pure (re-entrant safe), can be made resident (P)
'                                                6       File is a script (Arexx or Shell) (S)
'                                                7       Hold bit. if H+P (and R+E) are set the file can
'                                                                    be made resident on first load (OS 2.x and 3.0)
'                                                8       Group (D) : is delete protected
'                                                9       Group (E) : is executable
'                                               10       Group (W) : is writable
'                                               11       Group (R) : is readable
'                                               12       Other (D) : is delete protected
'                                               13       Other (E) : is executable
'                                               14       Other (W) : is writable
'                                               15       Other (R) : is readable
'                                             16-30      Reserved
'                                               31       SUID, MultiUserFS Only
'                                                                                                            */
  
  
'Delete forbidden (D)
If Mid(attrib_bin, 32, 1) = 1 Then
DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).image = ICN_Gray
End If


'Not writable (W)
If Mid(attrib_bin, 29, 1) = 1 Then
DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).image = ICN_Red
End If

'Not readable (R)
If Mid(attrib_bin, 28, 1) = 1 Then
DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).image = ICN_Gray
End If


'Is archive (A)
If Mid(attrib_bin, 27, 1) = 1 Then
DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).image = ICN_Green
End If

'Pure (re-entrant safe), can be made resident (P)
If Mid(attrib_bin, 26, 1) = 1 Then
DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).image = ICN_Yellow
DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).text = TmpChar & " [Pur]"
End If

'is executable
If Mid(attrib_bin, 22, 1) = 1 Then
DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).image = ICN_Blue
End If

'Not executable (E)
If Mid(attrib_bin, 31, 1) = "1" And Decode_str_hex(DirEntry.byteSize) <> 0 Then
DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).image = ICN_Yellow
DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).text = TmpChar & " [Exe]"
End If

'File is a script (Arexx or Shell) (S)
If Mid(attrib_bin, 25, 1) = 1 Then
DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).image = ICN_Yellow
DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).text = TmpChar & " [Scr]"
End If

'First load/Resident
If Mid(attrib_bin, 24, 1) = 1 Then
DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).image = ICN_Yellow
End If


'is delete protected
If Mid(attrib_bin, 23, 1) = 1 Then
DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).image = ICN_Gray
End If


'is writable
If Mid(attrib_bin, 21, 1) = 1 Then
DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).image = ICN_Green
End If

'is readable
If Mid(attrib_bin, 20, 1) = "1" Then
DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).image = ICN_Green
End If



'Folders
If Decode_str_hex(DirEntry.File_lenght) = 0 Then
DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).image = "folder1"
DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).text = "\" & TmpChar & " ..."
End If

'is Info file (System)
If InStr(DirEntry.Comment, ".info") >= 1 Then
DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).image = ICN_Info
End If

'If DirEntry.ERASED <> &H70 Then
'DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).image = "Hid_file"
'End If

Debug.Print "Dir extension :"; CLng(Decode_str_hex(DirEntry.extension))
Debug.Print "Comment :"; DirEntry.Comment
Debug.Print "Name :"; DirEntry.Name
Debug.Print "Date :"; CLng(Decode_str_hex(DirEntry.days))
Debug.Print "Header key :"; CLng(Decode_str_hex(DirEntry.headerKey))
Debug.Print "Next link :"; CLng(Decode_str_hex(DirEntry.nextLink))
Debug.Print "Dir parent :"; CLng(Decode_str_hex(DirEntry.parent))
Debug.Print "Real Entry :"; CLng(Decode_str_hex(DirEntry.realEntry))
Debug.Print "Type :"; CLng(Decode_str_hex(DirEntry.type))
Debug.Print "Dir extension :"; CLng(Decode_str_hex(DirEntry.extension))
Debug.Print "#####################"

Debug.Print Decode_str_hex(DirEntry.File_lenght)
If CLng(Decode_str_hex(DirEntry.File_lenght)) > 0 Then
DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).text = DskCenter.ProDos_tree.Nodes.Item("F" & Nb_Fichiers).text & " (" & Decode_str_hex(DirEntry.File_lenght) & ")" & AmigaDos_DATE(0)
End If

finboucle:


' ***************************************************************************************
Nb_Fichiers = Nb_Fichiers + 1
filter_loop:
' ***************************************************************************************
  
Vol_Name:

      actual_seek = actual_seek + 512
      Seek #liX, actual_seek
      Get #liX, , DirEntry
      
 

TmpInt = 0

Do Until Left(DirEntry.access, 2) = Chr(0) + Chr(0) And _
         Left(DirEntry.Comment, 1) <> Chr(0) And _
         DirEntry.commLen <= 79 And Left(DirEntry.Comment, 1) < Chr(&H81) And _
         Mid(DirEntry.Comment, DirEntry.commLen + 1, 1) = Chr(0)
         
      TmpInt = TmpInt + 1: If TmpInt = 20 Then Exit Do
      actual_seek = actual_seek + 512
      Seek #liX, actual_seek
      Get #liX, , DirEntry
      
     ' If Decode_str_hex(DirEntry.access) = 0 And Decode_str_hex(DirEntry.realEntry) <> 0 And Left(DirEntry.comment, 1) = Chr(0) Then GoTo exitloop
 Loop

 If TmpInt = 10 Then Exit Do

Dsk_LED (True)

Loop

exitloop:

  Close #liX
  
 Nb_fichiers_cpc = Nb_fichiers_cpc - 1

 ' Call PutTxtFile("cat.log", log, False)' write log values.
 ' Debug.Print enum_Folders
 Dsk_LED (False)
End Function




