Attribute VB_Name = "Scan_SNES_info"
Option Explicit

' ***********************************************************************************************
' *          Game Boy info                                                                      *
' ***********************************************************************************************

 
 Public Sub Get_SNES_infos(File_Name As String)
  Dim offset As Long
  Dim clmhdr2 As ColumnHeader
 
 Dim Header_datas As String * 21

  
    DskCenter.ListView_dos_header.ColumnHeaders.Clear
    '-----------------------------------------------------
    ' add columns to listview control
    '-----------------------------------------------------
    Set clmhdr2 = DskCenter.ListView_dos_header.ColumnHeaders.Add()
    clmhdr2.text = "Properties:"
    clmhdr2.Width = (DskCenter.ListView_dos_header.Width / 2) - 100
         
    Set clmhdr2 = DskCenter.ListView_dos_header.ColumnHeaders.Add()
    clmhdr2.text = "Value:"
    clmhdr2.Width = (DskCenter.ListView_dos_header.Width / 2) - 230
    clmhdr2.Alignment = lvwColumnLeft
    
    'reset ListView_dos_header
    DskCenter.ListView_dos_header.ListItems.Clear
    
    
    offset = 32689
    
    LiX = FreeFile

    Open File_Name For Binary Access Read As #LiX Len = 21
    
    
    Get #LiX, 9, Header_datas
    DskCenter.ListView_dos_header.ListItems.Add , , "SWC identifier:"
    If Left(Header_datas, 3) = Chr(&HAA) + Chr(&HBB) + Chr(&H4) Or Left(Header_datas, 3) = Chr(&HAA) + Chr(&HBB) + Chr(&H3) Then
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = "Passed.": offset = 33201
    Else
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = "Not Found."
    End If
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).Bold = True
    
    Get #LiX, 1, Header_datas
    DskCenter.ListView_dos_header.ListItems.Add , , "Size(#1):"
    If CLng((Asc(Mid(Header_datas, 1, 1)) * CLng(&H100)) + CLng(Asc(Mid(Header_datas, 2, 1)))) = CLng((((FileLen(File_Name) - 512) / 1024) / 8)) Then
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = "Passed.": offset = 33201
    Else
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = "Not Found."
    End If
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).Bold = True
    
    
    DskCenter.ListView_dos_header.ListItems.Add , , "Extra Header:"
    
    If FileLen(File_Name) / CLng(Abs(CLng(&H8000))) = 512 Then
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = "Passed.": offset = 33201
    Else
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = "Not Found.":
    End If
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).Bold = True
    
    
    Get #LiX, offset, Header_datas
    DskCenter.ListView_dos_header.ListItems.Add , , "Manufacturer ID:"
    
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = "Hex: " & format(Hex(Asc(Mid(Header_datas, 2, 1))), "##00") & format(Hex(Asc(Mid(Header_datas, 1, 1))), "##00")
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).Bold = True

 
    
    DskCenter.ListView_dos_header.ListItems.Add , , "Rom ID:"
    
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = "Hex: " & format(Hex(Asc(Mid(Header_datas, 6, 1))), "##00") & format(Hex(Asc(Mid(Header_datas, 5, 1))), "##00") & format(Hex(Asc(Mid(Header_datas, 4, 1))), "##00") & format(Hex(Asc(Mid(Header_datas, 3, 1))), "##00")
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).Bold = True


   Get #LiX, offset + 16, Header_datas
    DskCenter.ListView_dos_header.ListItems.Add , , "Title:"
    
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = Left(Header_datas, 21)
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).Bold = True

     
   Get #LiX, offset + 37, Header_datas
    DskCenter.ListView_dos_header.ListItems.Add , , "Speed:"
    
    If (Asc(Left(Header_datas, 1)) And &HF0) Then
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = "FastROM"
    Else
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = "SlowROM"
    End If
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).Bold = True
      
      If (Asc(Left(Header_datas, 1)) And &HF) Then
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = "HiROM"
    Else
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = "LoROM"
    End If
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).Bold = True
  

     
     Get #LiX, offset + 38, Header_datas
    DskCenter.ListView_dos_header.ListItems.Add , , "Rom Type:"
    
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = SNES_infos(CByte(Asc(Left(Header_datas, 1))))
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).Bold = True
 
 

      Get #LiX, offset + 39, Header_datas
    DskCenter.ListView_dos_header.ListItems.Add , , "Rom size:"
    
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = CByte(Asc(Left(Header_datas, 1))) - 7 & "MBytes."
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).Bold = True
    

      Get #LiX, offset + 41, Header_datas
    DskCenter.ListView_dos_header.ListItems.Add , , "Country:"
    
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = SNES_CART_Country(CByte(Asc(Left(Header_datas, 1))))
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).Bold = True
 
    
    DskCenter.ListView_dos_header.ListItems.Add , , "Licence:"
        DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = CByte(Asc(Mid(Header_datas, 2, 1)))
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).Bold = True
    
    DskCenter.ListView_dos_header.ListItems.Add , , "Version:"
        DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = CByte(Asc(Mid(Header_datas, 3, 1)))
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).Bold = True
 
    DskCenter.ListView_dos_header.ListItems.Add , , "Inv checksum:"
        DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = "Hex: " & format(Hex(Asc(Mid(Header_datas, 5, 1))), "##00") & format(Hex(Asc(Mid(Header_datas, 4, 1))), "##00")
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).Bold = True
 
     DskCenter.ListView_dos_header.ListItems.Add , , "Checksum:"
        DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).SubItems(1) = "Hex: " & format(Hex(Asc(Mid(Header_datas, 7, 1))), "##00") & format(Hex(Asc(Mid(Header_datas, 6, 1))), "##00")
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.count).Bold = True

 
    Close #LiX

 End Sub


Private Function SNES_infos(Tag As Byte) As String


Select Case Tag
Case 0
    SNES_infos = "ROM"
Case 1
    SNES_infos = "ROM,RAM"
Case 2
    SNES_infos = "ROM,SRAM"
Case 3
    SNES_infos = "ROM,DSP1"
Case 4
    SNES_infos = "ROM,RAM,DSP1"
Case 5
    SNES_infos = "ROM,SRAM,DSP1"
Case 19
    SNES_infos = "ROM,SuperFX"
Case 21
    SNES_infos = "ROM,SRAM,SuperFX"
Case 69
    SNES_infos = "ROM,SRAM,S-DD1"
Case 227
    SNES_infos = "ROM,Z80GB"
Case 243
    SNES_infos = "ROM,?(1)"
Case 246
    SNES_infos = "ROM,DSP2"
 Case Else
    SNES_infos = "UNKNOWN"
End Select

End Function
 Private Function SNES_CART_Country(Tag As Integer) As String

If Tag > 14 Then Tag = 14

Dim Cart_Country
Cart_Country = Array("Japan (NTSC)", "USA (NTSC)", "Australia, Europe, Oceania & Asia (PAL)", _
                     "Sweden (PAL)", "Finland (PAL)", "Denmark (PAL)", "France (PAL)", _
                     "Holland (PAL)", "Spain (PAL)", "Germany, Austria & Switzerland (PAL)", _
                      "Italy (PAL)", "Hong Kong & China (PAL)", "Indonesia (PAL)", _
                      "Korea (PAL)", "UNKNOWN")

 On Error GoTo Dimerror
 SNES_CART_Country = Cart_Country(Tag)
 Exit Function

Dimerror:
 SNES_CART_Country = "UNKNOWN"

End Function
