Attribute VB_Name = "Scan_Ti99_Dir"
Option Explicit


' Ti99 (V9T9 format)
 ' PC99 Single and Double Density.
 ' TI99 with MESS specifications
 
 
Public Function Read_Cat_Ti99(fileName As String, Optional Dsk_sys_tag As String, Optional undelete As Boolean = False, Optional undel_name As String = "", Optional Ch_attrib As String = "", Optional Get_Property As Boolean = False, Optional Open_Frame As Boolean = True, Optional Folder_offset As Integer = 0, Optional Parent_Name As String = "ROOT")
On Error GoTo Err_eof

Dsk_LED (True)


Dim length As Single
Dim DirEntry As Ti99_DirEntry
Dim Ti99_BootStap As Ti99_BootStap
Dim Item As ListItem
Dim attr_Tag As Double
Dim Pas_de_cat As Byte
Dim a As Integer
Dim actual_seek As Long  ' seek memory for multiple-blocs > 16 ko.
Dim seek_compter ' seek offset for multiple-blocs > 16 ko.
Dim total_blocs As Long
Dim Nb_Fichiers As Integer
Dim index_tree As Integer
Dim attr_str As String
Dim Dir_Len As Integer
Dim Mess_Header_Len As Single


Call init_c64

'init C64 listview.
Set DskCenter.Info_image.Picture = DskCenter.ImageList_msk.ListImages("info_on").Picture

 liX = FreeFile

  Set Item = DskCenter.C64.ListItems.Add()

  Open fileName For Binary As #liX Len = Len(Ti99_BootStap)
  
 Select Case computer
   
   Case "TI99-V9T9"
  ' pick-up cat address
  actual_seek = 1
  Dir_Len = 256
  DskCenter.Label_Directory.Caption = "Directory: Ti99 V9T9 Format."
  
   Case "TI99-PC99PS"
  ' pick-up cat address
  actual_seek = 48
  Dir_Len = 334
  DskCenter.Label_Directory.Caption = "Directory: Ti99 PC99 SD Format."
   
   Case "TI99-PC99PD"
  ' pick-up cat address
  actual_seek = 99
  Dir_Len = 340
  DskCenter.Label_Directory.Caption = "Directory: Ti99 PC99 DD Format."
   
   Case "TI99-MESS"
  ' pick-up cat address
  Get #liX, 9, Mess_Header_Len ' = Len 80 bytes.
  Debug.Print "Mess header:"; Mess_Header_Len
  actual_seek = Mess_Header_Len + 1
  Dir_Len = 256
  DskCenter.Label_Directory.Caption = "Directory: Ti99 Mess Hard disk."
  
End Select

  Get #liX, actual_seek, Ti99_BootStap
  
  Call Ti99_Read_Info(Ti99_BootStap)
  Close #liX

Select Case computer
   Case "TI99-V9T9"
        Item.text = "V9T9:" & Ti99_BootStap.Name
        actual_seek = 513
   Case "TI99-PC99PS"
        Item.text = "PC99-SD:" & Ti99_BootStap.Name
        actual_seek = 382
   Case "TI99-PC99PD"
        Item.text = "PC99-DD:" & Ti99_BootStap.Name
        actual_seek = 439
   Case "TI99-MESS"
        Item.text = "Mess hard disk:" & Ti99_BootStap.Name
        actual_seek = 593 '80 Mess header + 512 Bootstrap + 1
End Select

 Item.SmallIcon = ICN_Disk

liX = FreeFile
Open fileName For Binary As #liX Len = Len(DirEntry)


  Seek #liX, actual_seek
 
  DskCenter.C64.ListItems.Item(DskCenter.C64.ListItems.Count).Bold = True
  DskCenter.C64.ListItems.Item(DskCenter.C64.ListItems.Count).ForeColor = &HE08C47

  
  Get #liX, actual_seek, DirEntry
 

'******************************************************************************************
 
 
 Nb_fichiers_cpc = 0 ' file index for multi-files blocs
 total_blocs = 0     ' Used memory bloc -> 1024 bytes per bloc
 index_tree = 1      ' Key index compter for treeview
 
  Do While Chk_ASCII(DirEntry.file_Name) = "OK" Or Left(DirEntry.file_Name, 1) = Chr(0)
  
  Nb_Fichiers = Nb_Fichiers + 1
  
  
  Get #liX, actual_seek, DirEntry
    
    Dsk_LED (True)
    
 ' Jump FAT
  If computer <> "TI99-V9T9" And Left(DirEntry.file_Name, 1) = Chr(0) Then GoTo filter_loop
 
 ' Stop if null char with V9T9
 If computer = "TI99-V9T9" And Chk_ASCII(DirEntry.file_Name) <> "OK" Then Exit Do
   
  
  If Chk_ASCII(DirEntry.file_Name) <> "OK" Then GoTo exitloop
      
 Set Item = DskCenter.C64.ListItems.Add()
 Item.text = DirEntry.file_Name

 
TmpChar = ""
    
 ' Attributs:
 ' ---------
 '        Hw             Lw
 '         8 x x x 4 x 2 1    ___
 '         v       v   v +-> [FIX]/[PRG]
 '       [VAR]   [R/O][INT]
 '
 ' Byte# 1 = Program.[PRG]/ 0= Fix (May be Fixe-lenght variable)
 ' Byte# 2 = Binary.[INT] / 0= Dis (May be ASCCI files)
 ' Byte# 3 = .
 ' Byte# 4 = Read only.[R/O]/ 0= Random access.
 ' Byte# 5 = Updated.
 ' Byte# 6 = Dsk image (HD Dir).
 ' Byte# 7 = .
 ' Byte# 8 = Variable-length record.[VAR]
 
 Dim filetype As Integer
 filetype% = DirEntry.Attribut
               filetype% = filetype% And &H8B         ' Get rid of reserved bits: 2,4-6
               If filetype% And 8 Then
               TmpChar = "Protected Access"
               Else
               TmpChar = "Random Access"
               End If
               filetype% = filetype% And 247
   
 Select Case filetype% ' Mask = "10000011"
 
                Case 0 '"00000000"
                TmpChar = TmpChar & " - Dis/Fix"
                Case 1 '"00000001"
                TmpChar = TmpChar & " - Program"
                Case 2 '"00000010"
                TmpChar = TmpChar & " - Bin/Fix"
                Case 3 '"00000011"
                ' + unused +
                Case 128 '"10000000"
                TmpChar = TmpChar & " - Dis/Var"
                Case 130 '"10000010"
                TmpChar = TmpChar & " - Bin/Var"
                Case Else
                 TmpChar = TmpChar & " - Unknown"
 End Select

 DskCenter.C64.ListItems.Item(DskCenter.C64.ListItems().Count).SubItems(2) = TmpChar
  
TmpChar = ""

If DirEntry.Update <> 0 Then
TmpChar = TmpChar & "[" & (DirEntry.Update And &HF8) & "/" & (DirEntry.Update And &HF8) & "/" & (1980 + (DirEntry.Update And &H7)) & "]"
End If

If DirEntry.Creation <> 0 Then
TmpChar = TmpChar & "[" & (DirEntry.Creation And &HF8) & "/" & (DirEntry.Creation And &HF8) & "/" & (1980 + (DirEntry.Creation And &H7)) & "]"
End If

DskCenter.C64.ListItems.Item(DskCenter.C64.ListItems().Count).SubItems(3) = TmpChar

If DirEntry.Attribut = 0 Then Item.SmallIcon = ICN_Green: GoTo end_loop

' 0x01 : set for program files (0=program 1=Deleted)
If Mid(ConvBin(CDbl(DirEntry.Attribut), 8), 8, 1) Then Item.SmallIcon = "Erased" ': GoTo end_loop
                                
' 0x02 : set for binary files
If Mid(ConvBin(CDbl(DirEntry.Attribut), 8), 7, 1) Then Item.SmallIcon = ICN_Yellow ': GoTo end_loop

' 0x08 : set if file is write-protected
If Mid(ConvBin(CDbl(DirEntry.Attribut), 8), 5, 1) Then Item.SmallIcon = ICN_Red: GoTo end_loop

' 0x10 : set if file has been modified since last backup
If Mid(ConvBin(CDbl(DirEntry.Attribut), 8), 4, 1) Then Item.SmallIcon = ICN_Gray: GoTo end_loop

' 0x20 : set if file is a DSK image (HFDC HD only)
If Mid(ConvBin(CDbl(DirEntry.Attribut), 8), 3, 1) Then Item.SmallIcon = ICN_Blue: GoTo end_loop

' 0x80 : set if file uses variable-length records
If Mid(ConvBin(CDbl(DirEntry.Attribut), 8), 1, 1) Then Item.SmallIcon = ICN_Yellow: GoTo end_loop
end_loop:

Debug.Print Asc(Mid(DirEntry.Clusters, 3, 1))

Dim FileLength As Double


filetype% = DirEntry.Attribut And &H8B  ' Get rid of reserved bits: 2,4-6
filetype% = filetype% And 247

FileLength = CDbl(DirEntry.File_Len)
           
 If filetype% < 128 Then FileLength = FileLength - 256 + DirEntry.EOFOffset

 DskCenter.C64.ListItems.Item(DskCenter.C64.ListItems().Count).SubItems(1) = format(FileLength / 1000, "###0.##K")

finboucle:

' ***************************************************************************************
Nb_fichiers_cpc = Nb_fichiers_cpc + 1
total_blocs = total_blocs + FileLength


filter_loop:
' ***************************************************************************************
  index_tree = index_tree + 1
  actual_seek = actual_seek + Dir_Len
 Dsk_LED (False)
 
Loop

exitloop:

  Close #liX
  
  
  If Nb_fichiers_cpc = 0 Then
  Set Item = DskCenter.C64.ListItems.Add()
  Item.text = " Empty disk."
  Item.SmallIcon = ICN_Disk
  DskCenter.C64.ListItems.Item(DskCenter.C64.ListItems.Count).Bold = True
  DskCenter.C64.ListItems.Item(DskCenter.C64.ListItems.Count).ForeColor = &HE04040
  
  Else
  
  Set Item = DskCenter.C64.ListItems.Add()
  Item.text = " " & Nb_fichiers_cpc & " Files."
  Item.SmallIcon = ICN_Disk


  DskCenter.C64.ListItems.Item(DskCenter.C64.ListItems.Count).Bold = True
  DskCenter.C64.ListItems.Item(DskCenter.C64.ListItems.Count).ForeColor = &HE04040
  
  
  Set Item = DskCenter.C64.ListItems.Add()
  Item.text = " Total: " & format(total_blocs / 1000, "###0.###K.")

  DskCenter.C64.ListItems.Item(DskCenter.C64.ListItems.Count).Bold = True
  DskCenter.C64.ListItems.Item(DskCenter.C64.ListItems.Count).ForeColor = &HE04040
  
  End If
 
 ' Call PutTxtFile("cat.log", log, False)' write log values.
 ' Debug.Print enum_Folders

Dsk_LED (False)
Exit Function

Err_eof:
Close #liX

End Function



' ***********************************************************************************************
' *          TI99 Bootstrap                                                                     *
' ***********************************************************************************************

Public Sub Ti99_Read_Info(Ti99_BootStap As Ti99_BootStap)
  Dim clmhdr2 As ColumnHeader
  Dim Boot_info As bootstrap_Fat16
  Dim tmpchr As String
  Dim tmpval As Long
  Dim volume_info As Ms_Volume
  
    DskCenter.ListView_dos_header.ColumnHeaders.Clear
    '-----------------------------------------------------
    ' add columns to listview control
    '-----------------------------------------------------
    Set clmhdr2 = DskCenter.ListView_dos_header.ColumnHeaders.Add()
    clmhdr2.text = "Properties:"
    clmhdr2.Width = 2 * (DskCenter.ListView_dos_header.Width / 3) - 530
         
    Set clmhdr2 = DskCenter.ListView_dos_header.ColumnHeaders.Add()
    clmhdr2.text = "Value:"
    clmhdr2.Width = (DskCenter.ListView_dos_header.Width / 3) + 200
    clmhdr2.Alignment = lvwColumnLeft
    
    'reset ListView_dos_header
    DskCenter.ListView_dos_header.ListItems.Clear
    
  
DskCenter.ListView_dos_header.ListItems.Add , , "Volume label:"
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = Ti99_BootStap.Name
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).Bold = True
    
DskCenter.ListView_dos_header.ListItems.Add , , "Protected disk:"

    If Chr(Ti99_BootStap.Protection) = "P" Then
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = "Yes"
    Else
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = "No"
    End If
    
    
DskCenter.ListView_dos_header.ListItems.Add , , "ID Tag (DSK/WIN)"
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = Ti99_BootStap.Id
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).Bold = True
    
    
DskCenter.ListView_dos_header.ListItems.Add , , "Density:"

' density: 1 (FM SD), 2 (MFM DD), or 3 (MFM HD)
  
   Select Case Ti99_BootStap.Density
   Case 1
       DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = "FM SD type."

   Case 2
       DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = "MFM DD type."
   Case 3
       DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = "MFM HD type."
   Case Else
       DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = "Unknown."
   End Select
   
DskCenter.ListView_dos_header.ListItems.Add , , "Side:"
    Select Case Ti99_BootStap.Heads
    Case 1
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = "1 side."
    Case 2
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = "2 sides."
    
    Case Else
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = "Unknown."
    End Select
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).Bold = True
   
DskCenter.ListView_dos_header.ListItems.Add , , "Physicals records:"
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = Ti99_BootStap.Totphysrecs
      
DskCenter.ListView_dos_header.ListItems.Add , , "Sectors per track:"
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = Ti99_BootStap.secspertrack
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).Bold = True

DskCenter.ListView_dos_header.ListItems.Add , , "Tracks per side:"
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = Ti99_BootStap.Cylinders


DskCenter.ListView_dos_header.ListItems.Add , , "Subdirectories:"
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = Ti99_BootStap.Dsk_Subdir
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).Bold = True

    DskCenter.ListView_dos_header.ListItems.Add , , "Total space:"
    tmpval = 256 * (CSng(Ti99_BootStap.Cylinders)) * (CSng(Ti99_BootStap.Heads)) * (CSng(Ti99_BootStap.secspertrack))
    tmpchr = format(tmpval / 1000, "#####0.000") & "Ko."
    Bootstrap_Image_len = tmpval
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = tmpchr
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).Bold = True
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).ListSubItems(1).Bold = True

End Sub

