Attribute VB_Name = "SUB_DEF"
Option Explicit

Public Function read_type(File_Name As String, Optional get_info As Boolean) As String
Dim taille_disk As Double
Dim nametemp  As String
Dim pc_boot As bootstrap_Fat16
Dim d_header As d_header
Dim DirEntry As DirEntry
Dim Mess_tag As Dsk_Mess_tag
Dim Size As Long
Dim Track_Header As Track_Header
Dim Pas_de_cat As Byte
Dim bootstrap_Fat16 As bootstrap_Fat16
Dim Attribut_str As String * 3


If Cut_Name(File_Name) = "" Then Exit Function

Attribut_str = UCase(GetFileAttrib(File_Name))

CPMText = ""

On Error Resume Next

Lix = FreeFile

' change scan of Temp directory  (Work directory =zipped directory)
If TmpFile = True And File_Name <> "" Then
nametemp = Cut_Name(File_Name)
File_Name = Tmp_App_Path & "\" & nametemp
End If

  Open File_Name For Random Access Read As #Lix Len = Len(d_header)
  
  Get #Lix, 1, d_header
  
  Close #Lix

Dim incompatible As String * 5

Lix = FreeFile
Open File_Name For Binary Access Read As #Lix
 ' PC Coco Dsk for header specifications.
  Get #Lix, 1, COCO_tag1 ' Color Computer tag / Linux : EB xx 90
  Get #Lix, 1, pc_boot ' Pc generic Bootstrap
  Get #Lix, 1, Mess_tag
  Get #Lix, 1, bootstrap_Fat16
  Get #Lix, 1, TI99_Vol_Name
  
  
 ' PC MS-DOS test (for boot specifications)
  Get #Lix, 4, PC_tag1 ' MSDOS tag
  Get #Lix, 55, PC_tag2 ' MSDOS tag (Fat tag)
  
 ' PC Ti99 Dsk - Mess old resease - (for header specifications)
  Get #Lix, 14, TI99_tag1 ' MSDOS tag
  
 ' MSX DOS test (for boot specifications)
  Get #Lix, 1, Msx_tag3
  Get #Lix, 78, Msx_tag1
  Get #Lix, 173, Msx_tag2
  
 ' CPCemu CP/m (for boot specifications)
  Get #Lix, 257, incompatible
  Get #Lix, 42, CPM68k
  
  ' PC combatible bootStrap for MSDOS < or > 4.0
  Get #Lix, 355, PC_tag3
  Get #Lix, 471, PC_tag4
  Get #Lix, 511, PC_tag5
  
  Get #Lix, 1648, Pas_de_cat
  Get #Lix, 1648, CPMText
  
  Get #Lix, 78657, COCO_tag2
 
  Get #Lix, 32753, Sms1
  Get #Lix, 33265, Sms2
  
Close #Lix

 ' Rom Consoles roms.
 Debug.Print "ROM :"; Attribut_str
  Select Case Trim(Attribut_str)
         Case "GB" ' GameBoy
              read_type = Scan_Rom(File_Name, Msx_tag3, Attribut_str): GoTo end_scan
         Case "CGB" ' GameBoy color (1)
              read_type = Scan_Rom(File_Name, Msx_tag3, Attribut_str): GoTo end_scan
         Case "GBC" ' GameBoy color (2)
              read_type = Scan_Rom(File_Name, Msx_tag3, Attribut_str): GoTo end_scan
         Case "NES" ' Nintendo
              read_type = Scan_Rom(File_Name, Msx_tag3, Attribut_str): GoTo end_scan
         Case "A78" ' Atari 7800
              read_type = Scan_Rom(File_Name, Msx_tag3, Attribut_str): GoTo end_scan
         Case "ELF" ' GameBoy
              read_type = Scan_Rom(File_Name, Msx_tag3, Attribut_str): GoTo end_scan
         Case "V64" ' Super Nintendo
              read_type = Scan_Rom(File_Name, Msx_tag3, Attribut_str): GoTo end_scan
         Case "SG" ' GameBoy
              read_type = Scan_Rom(File_Name, Msx_tag3, Attribut_str): GoTo end_scan
         Case "GG" ' Game Gear
              read_type = Scan_Rom(File_Name, Msx_tag3, Attribut_str): GoTo end_scan
         Case "SMC" ' SNES
              read_type = Scan_Rom(File_Name, Msx_tag3, Attribut_str): GoTo end_scan
         Case "SMS" ' Sega Master System/Famicom
         'Sms 1 @ [0x7FF0]
              read_type = Scan_Rom(File_Name, Sms1, Attribut_str):
              If read_type = "SMS" Then GoTo end_scan
         'Sms 2 @ [0x81f0]
              read_type = Scan_Rom(File_Name, Sms2, Attribut_str): GoTo end_scan
         'Sms generic (extension validation! some atics roms...)
              If Attribut_str = "SMS" Then read_type = "SMS!": GoTo end_scan
         Case "LNX" ' Atari Lynx
              read_type = Scan_Rom(File_Name, Msx_tag3, Attribut_str): GoTo end_scan
         Case "DOL" ' Came Cube "dol" format.
              read_type = Scan_Rom(File_Name, Msx_tag3, Attribut_str): GoTo end_scan

  End Select

 ' CP/m 68k for motorola systems
   If CPM68k = "CP/M-68K" Then read_type = "CPM68K": GoTo end_scan
   
   
 ' CP/m 86 for intel 8086 systems (IBM XT)
   If Mid(Msx_tag3, 1, 3) = Chr(&HEB) + Chr(&H2B) + Chr(&H90) Then read_type = "CPM86": GoTo end_scan
   
 ' MPM boot.("MP/M II V2.1 Loader")
   If Mid(Msx_tag3, 107, 4) = "MP/M" Then read_type = "MPM": GoTo end_scan
   
   
 ' Dedicate Mess's format.
   If Mess_tag.E5_tag = &HE5 Then
   TmpChar = Left(Mess_tag.description_tag, 1)
    If Not (Asc(TmpChar) < 48 Or Asc(TmpChar) > 90) Then TmpChar = "": read_type = "MESS": GoTo end_scan
   End If
   
 ' Other computers feature.
 ' MSX MS-Dos Disk
   If UCase(Msx_tag1) = "MSXDOS  SYS" Then read_type = "MSXDOS": GoTo end_scan
   
 ' MSX ??-Dos Disk
   If UCase(Msx_tag2) = "MSXDOS  SYS" Then read_type = "MSXDOS": GoTo end_scan
 ' enhanced rechearch in boot header
   If InStr(1, (Msx_tag3), "MSXDOS  SYS") > 0 Then read_type = "MSXDOS": GoTo end_scan
 ' CP/m v3 for MSX.
   If InStr(1, (Msx_tag3), "CPM3    SYS") > 0 Then read_type = "MSXCPM3": GoTo end_scan

 
 ' Atari XL for DOS2.5 - "XFD"
   If Left((Msx_tag3), 3) = Chr(0) & Chr(3) & Chr(0) Then read_type = "ATARIDOS2.5": GoTo end_scan

 ' Atari ATR file
   If Mid(Msx_tag3, 17, 3) = Chr(0) & Chr(3) & Chr(0) Then read_type = "ATARIATR": GoTo end_scan
 

 
 ' Commodore Amiga file : ADF files
   If Left(Msx_tag3, 3) = Chr(&H44) & Chr(&H4F) & Chr(&H53) Then read_type = "AMIGAADF": GoTo end_scan
     
   
 ' Commodore Amiga file : ADF files- UAE custom
   If Left(Msx_tag3, 4) = "UAE-" Then read_type = "AMIGAADFCUST": GoTo end_scan


 ' Atari ST / STE Dos Compatible file : MSA files
   If Left(Msx_tag3, 3) = Chr(&HE) & Chr(&HF) & Chr(&H0) Then read_type = "DOSST": GoTo end_scan
 
 
 ' MaxiDos/MaxiDos+ by Simon Cooke.
 
 ' Raw format. (can't retrive tags!)
 '  If Mid(Msx_tag3, 24, 7) = "" Then read_type = "MAXIDOS1": GoTo end_scan
 
 ' MaxiDos "*.SAD" (configurable regular geometry) format. (header: 22)
   If Mid(Msx_tag3, 24, 7) = "MAXIDOS" Then read_type = "MAXIDOSSAD": GoTo end_scan
   If UCase(Mid(Msx_tag3, 24, 6)) = "SAMDOS" Then read_type = "SAMDOSSAD": GoTo end_scan
    
 ' MaxiDos "*.DSK" (normal format - 80 tracks, 10 sectors,512 bytes)" format.
   If Mid(Msx_tag3, 2, 7) = "MAXIDOS" Then read_type = "MAXIDOSDSK": GoTo end_scan
   If UCase(Mid(Msx_tag3, 2, 6)) = "SAMDOS" Then read_type = "SAMDOSDSK": GoTo end_scan
 
  ' B-Dos "*.DSK" Spectrum OS by Edwin Blink(normal format - 80 tracks, 10 sectors,512 bytes)" format.
   If Mid(Msx_tag3, 2, 5) = "B-DOS" Then read_type = "BDOSDSK": GoTo end_scan
  ' SAD spec
   If Mid(Msx_tag3, 24, 5) = "B-DOS" Then read_type = "BDOSSAD": GoTo end_scan
 
 ' PC DOS - MS-Dos Disk (x.x)
 ' feature PC_tag1
 '  Ms - DOS V5 = "MSDOS5.0"
 '  Ms - DOS V6 = "MSDSP6.0"
 '  Win 98 = "MSWIN4.0" (4D5357494E342E30)
 '  w95/ms-dos7 "*****IHC"
 '  Win 98 = "*****IHC"
 '  Trace Mountain = "*****IHC"
 '  Digital Research = "DIGITAL"
 
   If Left(UCase(PC_tag1), 5) = "MSDOS" Then read_type = "PCDOSMS": GoTo end_scan
   If UCase(PC_tag1) = "DIGITAL" Then read_type = "PCDOSDR": GoTo end_scan
  
   If UCase(PC_tag2) = "FAT12" Then read_type = "PCDOSFAT12": GoTo end_scan
   If UCase(PC_tag2) = "FAT16" Then read_type = "PCDOSFAT16": GoTo end_scan
   If UCase(PC_tag3) = "IBMBIO  COM" Then read_type = "PCDOSIBM": GoTo end_scan
   If UCase(PC_tag4) = "IBMBIO  COM" Then read_type = "PCDOSIBM": GoTo end_scan


'  Linux : EB xx 90 tag floppy boot.( if EBxx90 is not passed with FAT arguments,not DOS)
'  and incompatible media descritor.
  If Left(COCO_tag1, 1) = Chr(&HEB) And _
  Mid(COCO_tag1, 3, 1) = Chr(&H90) And _
  bootstrap_Fat16.Mediadescriptor < 240 Then read_type = "LINUX1": GoTo end_scan

'  Linux : EB xx 4C tag floppy boot.(tagged EB:69:"LILO")
  If Left(COCO_tag1, 1) = Chr(&HEB) And Mid(COCO_tag1, 3, 1) = Chr(&H4C) Then read_type = "LINUX2": GoTo end_scan

 ' Try to retrive MS dos boot strap.
 ' PC MS Generic :
If Asc(Mid(pc_boot.Nearjmp, 1, 1)) = &HEB Then
        ' PCdos Hard disk primary BootStrap
        
        ' if Fat index exist.
       If Asc(Mid(pc_boot.Nearjmp, 3, 1)) = &H90 And _
       Asc(Mid(PC_tag5, 1, 1)) = &H55 And _
       Asc(Mid(PC_tag5, 2, 1)) = &HAA And _
       Asc(Mid(pc_boot.Nearjmp, 2, 1)) = &H58 Then read_type = "PCDOSHD": GoTo end_scan

    If Asc(Mid(pc_boot.Nearjmp, 3, 1)) = &H90 And _
       Asc(Mid(PC_tag5, 1, 1)) = &H55 And _
       Asc(Mid(PC_tag5, 2, 1)) = &HAA _
       Then
       read_type = "PCDOSFAT16" 'Generic Fat16
       GoTo end_scan
    End If
    
     If Asc(Mid(PC_tag5, 1, 1)) = &H55 And _
       Asc(Mid(PC_tag5, 2, 1)) = &HAA _
       Then
       read_type = "PCDOSMS" 'Generic Fat16 < MSDOS v.4
       GoTo end_scan
     End If
            
End If


 ' TI99 - Disk image for old and Mess release (V9T9 format)
 '
 ' "TI99-V9T9"
 ' "TI99-PC99PS"
 ' "TI99-PC99PD"
 ' "TI99-MESS"
 '
   
   If Left(TI99_tag1, 3) = "DSK" _
   Or Left(TI99_tag1, 3) = "WIN" _
   Or InStr(TI99_Vol_Name, Chr(&HFE)) > 0 _
   Or Left(TI99_Vol_Name, 8) = "MComprHD" Then
    If Asc(Mid(TI99_Vol_Name, 19, 1)) > 2 Or Asc(Mid(TI99_Vol_Name, 20, 1)) > 3 Then GoTo Eif
      ' Mess Hard Disk
      If Left(TI99_Vol_Name, 8) = "MComprHD" Then
       read_type = "TI99-MESS" '"MH" = Mess Hard Disk
       GoTo end_scan
      End If
   
      ' V9T9 Image Disk
      If Left(TI99_tag1, 3) = "DSK" Then
       read_type = "TI99-V9T9" '"VS" = V9T9 Image Disk
       GoTo end_scan
      End If
      
      ' Tag "WIN" or "???" = PC99
      If InStr(TI99_Vol_Name, Chr(&HFE)) > 0 Then
       
       If Mid$(TI99_Vol_Name, InStr(TI99_Vol_Name, Chr$(&HFE)) + 4, 1) = Chr$(&H1) Then
            
            If Mid$(TI99_Vol_Name, InStr(TI99_Vol_Name, Chr(&HFE)) - 3, 3) = Chr$(&HA1) + Chr$(&HA1) + Chr$(&HA1) Then
            
            read_type = "TI99-PC99PD" '"PD" = PC99 Double Density
            GoTo end_scan
            End If
       
       
            If Mid$(TI99_Vol_Name, InStr(TI99_Vol_Name, Chr$(&HFE)) - 3, 3) = Chr$(0) + Chr$(0) + Chr$(0) Then
            
            read_type = "TI99-PC99PS" '"PS" = PC99 Single Density
            GoTo end_scan
            End If
      
       End If
       
      End If
Eif:  ' May be an Extend CPC Disk.
  End If
      
 ' - Disk image tag.
 ' Coco -
   If COCO_tag1 = Chr(0) & Chr(&H23) & Chr(0) & Chr(&H19) & Chr(&H10) Then read_type = "COCOJVC": GoTo end_scan
 
 ' Coco - DMK support.
   If COCO_tag1 = Chr(&HFF) & Chr(&H23) & Chr(0) & Chr(&H19) & Chr(&H10) Then read_type = "COCODMK": GoTo end_scan
 
 ' TDOS - Disk image tag.
 ' Oric 1/Atmos, Pravetz 8D compatible.
 ' SedOric System.
 If Left(Msx_tag3, 8) = "MFM_DISK" And Mid(Msx_tag3, 437, 7) = "SEDORIC" Then read_type = "ORICMFMSEDO": GoTo end_scan
 ' UnKnown System.
 If Left(Msx_tag3, 8) = "MFM_DISK" Then read_type = "ORICMFM": GoTo end_scan



 ' TRS DOS - Disk image tag.
 ' Regular RS-dos
 If Left(COCO_tag2, 32) = SPChar(4, Chr(&HFF)) & SPChar(28, Chr(&H0)) Then read_type = "COCO2": GoTo end_scan

 ' ??? TRS/New dos cat???
 If Mid(COCO_tag2, 185, 8) = SPChar(8, Chr(&H0)) And (Mid(COCO_tag2, 201, 3) = "BIN" Or Mid(COCO_tag2, 233, 3) = "BIN" Or Mid(COCO_tag2, 265, 3) = "BIN") Then read_type = "COCO2": GoTo end_scan

 If (Mid(COCO_tag2, 201, 3) = "BAS" Or Mid(COCO_tag2, 233, 3) = "BAS" Or Mid(COCO_tag2, 265, 3) = "BAS") Then read_type = "COCO2": GoTo end_scan


' Apple bootable devices.(Apple II Dos 3.3 compatibility)
  If COCO_tag1 = Chr(1) & Chr(&HA5) & Chr(&H27) & Chr(&HC9) & Chr(&H9) Then read_type = "APPLE1": GoTo end_scan

' Apple bootable devices. (Mac compatibility)
  If COCO_tag1 = Chr(1) & Chr(&H78) & Chr(&H8D) & Chr(&H0) & Chr(&HC0) Then read_type = "APPLE2": GoTo end_scan

' Apple bootable devices (ProDos compatibility)
  If COCO_tag1 = Chr(1) & Chr(&H38) & Chr(&HB0) & Chr(&H3) & Chr(&H4C) Then read_type = "APPLE3": GoTo end_scan
  
' Macintosh diskcopy header.
  Lix = FreeFile
   Dim Diskcopy_header_t As Diskcopy_header_t
   Open File_Name For Binary Access Read As #Lix
   Get #Lix, 1, Diskcopy_header_t
   Close #1
   
   ' Diskcopy tag
   If Diskcopy_header_t.private <> &H100 Then GoTo not_a_mac_disk
   
   If (Chk_file_integrity(Diskcopy_header_t.DiskName) <> "OK") And _
      (FileLen(File_Name) = Diskcopy_header_t.DataSize + Diskcopy_header_t.TagSize + 84) _
      Then read_type = "APPLE4": GoTo end_scan

not_a_mac_disk:

 ' BBC micro model B system.
  ' UnKnown System.
 If Mid(Msx_tag3, 16, 1) = Chr(&H24) And _
 Chk_ASCII(Left(Msx_tag3, 15)) = "OK" And _
 Attribut_str = "IMG" Then read_type = "BBC": GoTo end_scan

  ' TO8 SAP compession Format.
  ' UnKnown System.
 If Mid(Msx_tag3, 29, 5) = "S.A.P" And _
 Attribut_str = "SAP" Then read_type = "TO8SAP": GoTo end_scan

  ' GameBoy Advance Format (ROM-"BIN").
 If (Mid(Msx_tag3, 1, 4) = Chr(&H2E) + Chr(&H0) + Chr(&H0) + Chr(&HEA) Or Mid(Msx_tag3, 1, 4) = Chr(&H34) + Chr(&H0) + Chr(&H0) + Chr(&HEA) Or Mid(Msx_tag3, 1, 4) = Chr(&H37) + Chr(&H0) + Chr(&H0) + Chr(&HEA)) And _
 (Attribut_str = "BIN" Or Attribut_str = "GBA") Then read_type = "GBA": GoTo end_scan
  
  ' Atari 2600 (ROM-"BIN")/Vectrex 2048, 4094 & 8192 bytes.
 If (FileLen(File_Name) = 2048 Or FileLen(File_Name) = 4096 Or FileLen(File_Name) = 8192) And (Attribut_str = "BIN") Then
  
 'Binary scan
 
 ' Vectrex (ROM-"BIN") 2048, 4094 & 8192 bytes.
  If Left(COCO_tag1, 4) = Chr(&H44) + Chr(&HC3) + Chr(&H4) + Chr(&H9) Then read_type = "VEC": GoTo end_scan
 
 ' Atari 2600 (ROM-"BIN") 2048, 4094 & 8192 bytes.
     
       Dim A26 As String * 4
       Open File_Name For Binary Access Read As #Lix
       Get #Lix, FileLen(File_Name) - 3, A26
       Close #Lix

  If (A26 = Chr(&H0) + Chr(&HF0) + Chr(&H0) + Chr(&HF0) Or A26 = Chr(&HB4) + Chr(&HFA) + Chr(&HB4) + Chr(&HFA)) Then read_type = "A26": GoTo end_scan
 End If

If get_info = True Then

         DskCenter.Property_disk.Visible = True
         DskCenter.sna_info.Visible = False

DskCenter.info_dsk_1.text = "  Amstrad CPC device." & vbCrLf & Pc_Dsk_Format(File_Name)


If d_header.tracksize = 0 Then Size = (CSng(d_header.nbof_heads) * CSng(d_header.nbof_tracks) * 4864) / 1000
If d_header.tracksize > 0 Then Size = (CSng(d_header.nbof_heads) * CSng(d_header.nbof_tracks) * CSng(d_header.tracksize)) / 1000


'Display infos
EmuCPC_infos d_header.Tag, d_header.nbof_heads, d_header.nbof_tracks, d_header.tracksize, Size

End If
  
 
  taille_disk = (CInt(d_header.nbof_heads) * CSng(d_header.nbof_tracks) * CSng(Val(d_header.tracksize)))
  
  If Left(CPMText, 4) = "CP/M" Then read_type = "CPM": GoTo end_scan
  If Left(d_header.Tag, 12) = "MV - CPCEMU " Then read_type = "CPC": GoTo end_scan
  If Left(d_header.Tag, 12) = "EXTENDED CPC" Then read_type = "EXTENDED CPC": GoTo end_scan
    
' Old formats

'------ NO$CPC Image format -> Header 2 bytes => 1:Version.  2:Tracks.
'- DATA 178Kb (40 tracks, 9 sectors per track, 512 Bytes per track, sector
'          number C1 Hex to C9 Hex ).
'- CPM 169Kb   (40 tracks, 9 sectors per track, 512 Bytes per track, sector
'          number 41 Hex to 49 Hex ).
  
  Select Case FileLen(File_Name)
  
  Case 184322
  '40 tracks
  If Asc(Mid(d_header.Tag, 2, 1)) = &H40 Or Asc(Mid(d_header.Tag, 2, 1)) = &HC1 Then read_type = "NO$CPC40": GoTo end_scan
    
  Case 188230
  '41 tracks
  If Asc(Mid(d_header.Tag, 2, 1)) = &H41 Or Asc(Mid(d_header.Tag, 2, 1)) = &HC2 Then read_type = "NO$CPC41": GoTo end_scan
  
  Case 193538
  '42 tracks
  If Asc(Mid(d_header.Tag, 2, 1)) = &H42 Or Asc(Mid(d_header.Tag, 2, 1)) = &HC3 Then read_type = "NO$CPC42": GoTo end_scan
       
  End Select
    
  ' No$CPC Bad header !  lenght tag <> real lenght
  
    If FileLen(File_Name) = 184322 Then
    'Tracks tag error.
    If Asc(Mid(d_header.Tag, 2, 1)) = &H41 Or Asc(Mid(d_header.Tag, 2, 1)) = &H42 Then read_type = "NO$CPC40!"
    If Asc(Mid(d_header.Tag, 2, 1)) = &HC2 Or Asc(Mid(d_header.Tag, 2, 1)) = &HC3 Then read_type = "NO$CPC40!"
    GoTo end_scan
    End If
    
    If FileLen(File_Name) = 188230 Then
    'Tracks tag error.
    If Asc(Mid(d_header.Tag, 2, 1)) = &H40 Or Asc(Mid(d_header.Tag, 2, 1)) = &H42 Then read_type = "NO$CPC41!"
    If Asc(Mid(d_header.Tag, 2, 1)) = &HC1 Or Asc(Mid(d_header.Tag, 2, 1)) = &HC3 Then read_type = "NO$CPC41!"
    GoTo end_scan
    End If
    
    If FileLen(File_Name) = 193538 Then
    'Tracks tag error.
    If Asc(Mid(d_header.Tag, 2, 1)) = &H40 Or Asc(Mid(d_header.Tag, 2, 1)) = &H41 Then read_type = "NO$CPC42!"
    If Asc(Mid(d_header.Tag, 2, 1)) = &HC1 Or Asc(Mid(d_header.Tag, 2, 1)) = &HC2 Then read_type = "NO$CPC42!"
    GoTo end_scan
    End If
    
 ' CopyQM tag -  ( IMG )
If COCO_tag1 = "CQ" + Chr(&H14) + Chr(&H0) + Chr(&H2) Then read_type = "COPYQM": DskCenter.Mnu_CQM_Conv.Enabled = True: GoTo end_scan Else DskCenter.Mnu_CQM_Conv.Enabled = False

    
 
' All dos retriving failed !

' Lenght Hook !
' Sam coup and ZX spectrum devices
' for non Dos disks images.
   If Mid(Msx_tag3, 24, 7) = "MAXIDOS" Then read_type = "MAXIDOSSAD": GoTo end_scan

If FileLen(File_Name) = 819200 Then read_type = "SAMDSK": GoTo end_scan
If FileLen(File_Name) = 819222 Then read_type = "SAMSAD": GoTo end_scan
  
  ' BBC micro model B system.
  ' *.IMG Type : UnKnown System.
  
  ' /!\ approximative scan! /!\
  If (Attribut_str = "IMG" Or Attribut_str = "BBC" Or Attribut_str = "SSD" Or Attribut_str = "DSK") And _
  (InStr(Msx_tag3, "!BOOT  ") Or InStr(Msx_tag3, "content$")) Then read_type = "BBC": GoTo end_scan

    
  
' Pas de catalogue sur le disque ( STD )
If Asc(Pas_de_cat) < 20 Then GoTo end_scan

If UCase(incompatible) <> "TRACK" Then read_type = "?": GoTo end_scan

  read_type = "!!!"
  
end_scan:
If read_type = "CPC" Or read_type = "CPM" Or read_type = "EXTENDED CPC" Then DskCenter.mnu_clean_sect.Enabled = True: DskCenter.Mnu_reformat.Enabled = True: DskCenter.Mnu_fixe_format.Enabled = True Else DskCenter.mnu_clean_sect.Enabled = False: DskCenter.Mnu_reformat.Enabled = False: DskCenter.Mnu_fixe_format.Enabled = False
  
' end of list
  
' Computer flag.(Zip tag)
Computer = read_type
 End Function
 

Public Sub read_disk_def()


Dim Data As String
Dim flag1, flag2, comp As Integer
comp = 0
Lix = FreeFile

Open App_Path & "\DISK.DEF" For Input As #Lix
    ' Definition des formats Dsk

Do While Not EOF(Lix)

Line Input #Lix, Data
        If InStr(1, UCase(Data), "DRIVE") <> 0 And InStr(1, UCase(Data), "DRIVE") < 3 Then disk_defint(comp).format = Val(Right(Data, Len(Data) - InStr(UCase(Data), "=")))

     If InStr(UCase(Data), "BEGIN") = 1 Then
     comp = comp + 1
        flag1 = InStr(2, Data, " ")
        flag2 = InStr(flag1 + 1, Data, " ")

        disk_defint(comp).Tag = Trim(Mid(Data, flag1, flag2))
        disk_defint(comp).Info = Trim(Right(Data, Len(Data) - flag2))

 
        
        Do While InStr(UCase(Data), "DENSITY") = 0
       Line Input #Lix, Data
        Loop
        
        flag1 = InStr(2, Data, " ")
        flag2 = InStr(flag1 + 1, Data, " ")
 
        disk_defint(comp).Formatage = Trim(Mid(Data, flag1, InStr(flag1 + 1, Data, ",")))
        disk_defint(comp).Densite = Trim(Mid(Data, InStr(flag1 + 1, Data, ",") + 1, flag2))
        disk_defint(comp).Cylindres = Val(Trim(Mid(Data, InStr(UCase(Data), "CYLINDERS") + 10, InStr(UCase(Data), "SIDES"))))
        disk_defint(comp).Faces = Val(Trim(Mid(Data, InStr(UCase(Data), "SIDES") + 6, InStr(UCase(Data), "SECTORS"))))
        disk_defint(comp).Secteurs = Val(Trim(Mid(Data, InStr(UCase(Data), "SECTORS") + 8, InStr(flag2, Data, ","))))
        
       If InStr(flag2, UCase(Data), "SKEW") = 0 Then disk_defint(comp).Taille_secteur = Val(Trim(Right(Data, Len(Data) - InStr(flag2, Data, ","))))
       If InStr(flag2, UCase(Data), "SKEW") > 1 Then disk_defint(comp).Taille_secteur = Val(Trim(Mid(Data, InStr(flag2, Data, ",") + 1, InStr(flag2, UCase(Data), "SKEW") - InStr(flag2, Data, ",")))): disk_defint(comp).Skew = Val(Trim(Right(Data, Len(Data) - InStr(flag2 + 1, UCase(Data), "SKEW") - 4)))
    End If
Loop
   Close #Lix
End Sub


Public Sub read_Mess_def()

Dim Data1 As String
Dim Data2 As String
Lix = FreeFile
App_Path = GetLongPathName(App.path)
If FileExists(App_Path & "\Mess_format.txt") = False Then Exit Sub
Open App_Path & "\Mess_format.txt" For Input As #Lix
    ' Definition des formats Dsk
cmp = 0
Do While Not EOF(Lix)
cmp = cmp + 1
Line Input #Lix, TmpChar
TmpInt = InStr(1, TmpChar, ",")
Data1 = Trim(Left(TmpChar, TmpInt - 1))
Data2 = Trim(Right(TmpChar, Len(TmpChar) - TmpInt))
Mess_id_disk(cmp).Id_System = Data1
Mess_id_disk(cmp).description = Data2
Loop
Mess_id_disk(cmp + 1).Id_System = "END"
Close #Lix
mess_cmp = cmp
End Sub

Public Sub info_disk(File_Name As String, offset As Integer, Optional getinfo As Boolean = True)
  
   DskCenter.Property_disk.Visible = True
   DskCenter.sna_info.Visible = False
   DskCenter.ListView1.ColumnHeaders(1).text = "Files:"
   
read_type File_Name, getinfo
read_cat File_Name, , , , offset
End Sub
Public Sub info_snap(File_Name As String)
    
    listview1_off
 
   DskCenter.Property_disk.Visible = False
   DskCenter.sna_info.Visible = True
  
read_type_sna File_Name, True
End Sub
Public Sub listview1_off()
   DskCenter.ListView1.ListItems.Clear
   DskCenter.ListView1.Enabled = False
   DskCenter.Info_image.Picture = DskCenter.ImageList_msk.ListImages("info_off").Picture
   DskCenter.Mnu_files_tool.Enabled = False
   DskCenter.Mnu_conversion.Enabled = False
   
   DskCenter.Mnu_filters.Visible = False
   DskCenter.Mnu_filters.Enabled = False
   
  On Error GoTo pas_de_header
  DskCenter.ListView1.ColumnHeaders(1).text = "Files:"
pas_de_header:
End Sub

Public Sub clean_similar_sectors(Filename As String)
Dim getEMU_tag_info As String * 256
Dim getEMU_tracks(255) As String * 4864
Dim inc, nb_tracks As Integer
Dim tracks_info As d_header
Dim fin_fich As Byte

fin_fich = &H2D

LiX1 = FreeFile
Open Filename For Binary Access Read As #LiX1 Len = 256
   Get #LiX1, 1, getEMU_tag_info
   Get #LiX1, 1, tracks_info
    Lix2 = FreeFile
         Open Filename & ".dsk" For Binary Access Write As #Lix2 Len = Len(getEMU_tag_info)
         Put #Lix2, 1, getEMU_tag_info
           Close #Lix2
  
Close #LiX1
  
  LiX1 = FreeFile

Open Filename For Binary Access Read As #LiX1 Len = 4864
   
      For inc = 0 To (tracks_info.nbof_tracks) - 1
   
      Get #LiX1, 256 + (inc * 4864), getEMU_tracks(inc + 1)
      Next inc
     Close #LiX1
  
   
Lix2 = FreeFile


         Open Filename & ".dsk" For Binary Access Write As #Lix2 Len = 4864
            For inc = 0 To (tracks_info.nbof_tracks) - 1
                Put #Lix2, 256 + (inc * 4864), getEMU_tracks(inc + 1)
            Next inc
            Put #Lix2, , fin_fich
         Close #Lix2
  
End Sub

Public Function check_sect_nb(Filename As String) As Integer
If Filename = "" Then Exit Function
Dim inc, nb_tracks As Integer
Dim tracks_info As d_header
Dim getEMU_tracks(10000) As String * 4864


DskCenter.Image_err_format.Picture = DskCenter.ImageList_msk.ListImages("repaire_off").Picture
LiX1 = FreeFile
Open Filename For Binary Access Read As #LiX1
   Get #LiX1, 1, tracks_info
Close #LiX1
 
LiX1 = FreeFile
inc = 0
Open Filename For Binary Access Read As #LiX1  ' ou tracks_info.tracksize

      Do While Not EOF(LiX1)
      Get #LiX1, 256 + (inc * 4864), getEMU_tracks(inc)
      inc = inc + 1
      Loop
      inc = inc - 1
     
Close #LiX1
  
 DskCenter.Image_err_format.Picture = DskCenter.ImageList_msk.ListImages("repaire_off").Picture
 DskCenter.ERREURS_Format.text = "Reported :" & inc & " Tracks !"
  
 If inc <> Val(tracks_info.nbof_tracks) Then DskCenter.ERREURS_Format.text = DskCenter.ERREURS_Format.text & vbCrLf & "> Error." Else DskCenter.ERREURS_Format.text = DskCenter.ERREURS_Format.text & vbCrLf & "Ok."

 check_sect_nb = inc
End Function
Public Function get_CPCEmu_ID(File_Name As String) As d_header

If File_Name = "" Then Exit Function
Lix = FreeFile
  
  Open File_Name For Random Access Read As #Lix Len = Len(get_CPCEmu_ID)
  Get #Lix, 1, get_CPCEmu_ID
  Close #Lix
    
  
 End Function
Public Sub Fixe_txt_info(File_Name As String, New_Text As String, rec_offset As Integer)


Lix = FreeFile
  
  Open File_Name For Binary Access Write As #Lix Len = Len(New_Text)
  Put #Lix, rec_offset, New_Text
  Close #Lix

End Sub
Public Function fixe_attrib_in_name(directory_name As String) As String
Dim a As Integer
Dim B_name As String
Dim mask_b As Double

fixe_attrib_in_name = ""
mask_b = 0

'Lecture des attributs et modifications par soustraction des masques (-&h80)
For a = 1 To 11
B_name = Mid(directory_name, a, 1)
If Asc(B_name) > &H80 And Asc(B_name) <> 0 Then mask_b = mask_b Or (2 ^ (11 - a)): B_name = Chr(Asc(B_name) - &H80)
If Asc(B_name) < &H20 Then B_name = "~"
If Asc(B_name) = 0 Then B_name = "~"
fixe_attrib_in_name = fixe_attrib_in_name + B_name
Next a


fixe_attrib_in_name = fixe_attrib_in_name + ConvBin(mask_b, 11)

End Function

Public Function attrib_icones(attrib As String)
Dim a As Integer
Dim B_name As String
Dim S_attrib As String

S_attrib = Right(attrib, 11)

For a = 1 To 11
DskCenter.Mnu_attribut(a).Checked = False:
B_name = Mid(attrib, a, 1)
If B_name = "1" Then DskCenter.Mnu_attribut(a).Checked = True
'icones selection
Next a


End Function

Public Function read_cpc_disk(Filename As String, Optional cpm As Boolean = False, Optional Sauve_CPC_DISK As Boolean = False, Optional CPCD_Format As Boolean = False, Optional native_offset As Integer = 257) As String

Dim tmp_disk As String
Dim CPCd_header As String * 4
Dim CPCd_data As String * 512
Dim tmp_disk_tag As String * 256
Dim tmp_disk_Tr_info As String * 257
Dim tmp_disk_datas As String * 4608
Dim offset_cpm, nb_secteurs, secteur, a  As Integer
Dim seek_EMUCPC, cmp As Double

If cpm = 1 Then offset_cpm = 0

If TmpFile = True Then

' Zipped file.
Filename = App_Path & "\" & TMP_Path & "\" & Cut_Name(Long_Nom_fichier_selec)

Else

' UnZippedd file.
Filename = Long_Nom_fichier_selec
End If


If native_offset = 257 Then

' EmuCPC image disk format.(default)
    
    seek_EMUCPC = 257
    Dim test_byte As String * 1
    Lix = FreeFile
    
    Open Filename For Binary Access Read As #Lix Len = 4608

    Do While Not EOF(1)
    
  On Error GoTo err_flag
  seek_EMUCPC = seek_EMUCPC + 256
  Get #Lix, seek_EMUCPC, tmp_disk_datas
  tmp_disk = tmp_disk + tmp_disk_datas
  seek_EMUCPC = seek_EMUCPC + 4608
  Get #Lix, seek_EMUCPC + 1, test_byte
  
  GoTo endloop
err_flag:
Exit Do
endloop:
  Loop
    Close #Lix
Else

' Raw image.

        Dim f1 As Single
        
            Lix2 = FreeFile
            f1 = FileLen(Filename) - native_offset
        Open Filename For Binary Access Read As #Lix2
            tmp_disk = Space$(f1)
            Get #Lix2, native_offset + 1, tmp_disk
        Close #Lix2
  
 End If
 
If Sauve_CPC_DISK = True And CPCD_Format = False Then
        ' Sauvegarde le fichier au format CPC Natif
        LiX1 = FreeFile
        TmpChar = App_Path & "\" & CPCn_Path & "\" & Left(Cut_Name(Filename), Len(Cut_Name(Filename)) - 4) & ".CPCn"
        Open TmpChar For Binary Access Write As #LiX1
        Put #LiX1, 1, tmp_disk
        Close #LiX1
End If

If Sauve_CPC_DISK = True And CPCD_Format = True Then
        ' Sauvegarde le fichier au format CPCD [secteur;00;bloc de 512(C1-C9);02)
        LiX1 = FreeFile
        TmpChar = App_Path & "\" & CPC_Path & "\" & Left(Cut_Name(Filename), Len(Cut_Name(Filename)) - 4) & ".CPC"
        Open TmpChar For Binary Access Write As #LiX1
        nb_secteurs = Int(Len(tmp_disk) / 28672) * 9
        cmp = 1
        
        For secteur = 0 To nb_secteurs
          For a = 0 To 8
          CPCd_header = Chr(secteur) & Chr(&H0) & Chr(&HC1 + a) & Chr(&H2)
          If Mid(tmp_disk, cmp, 512) = "" Then GoTo STRempty
        Put #LiX1, , CPCd_header
        CPCd_data = Mid(tmp_disk, cmp, 512)
        Put #LiX1, , CPCd_data
STRempty:
        cmp = cmp + 512
          Next a
        Next secteur
        
        Close #LiX1
End If

read_cpc_disk = tmp_disk

End Function


Public Function checkSum(string_var As String) As Double
Dim chksum As Double
Dim Counter, a As Double
Dim b As Integer
Counter = Len(string_var): chksum = 0
a = 1
While a < Counter
 b = Val(Mid(string_var, a, 1))
a = a + 1: chksum = chksum + b
Wend
Debug.Print chksum; "  &H"; Hex(chksum)
checkSum = chksum
'If UNT(chksum!) <> chk! Then Print "M/C data error! Please check the data.": End
End Function
Public Function init_filters()
If Cat_Dir = True Then DskCenter.Mnu_cat_dir.Checked = True
If Cat_RO = True Then DskCenter.Mnu_Cat_RO.Checked = True
If Cat_RO_Sys = True Then DskCenter.Mnu_Cat_RO_SYS.Checked = True
If Cat_Del = True Then DskCenter.Mnu_Cat_Deleted.Checked = True
If Cat_attics = True Then DskCenter.Mnu_Cat_illegals.Checked = True

If Dos_Dir = True Then DskCenter.Mnu_a_dos.Checked = True
If Dos_RO = True Then DskCenter.Mnu_ro_dos.Checked = True
If Dos_Sys = True Then DskCenter.Mnu_sys_dos.Checked = True
If Dos_hid = True Then DskCenter.Mnu_hid_dos.Checked = True
If Dos_Del = True Then DskCenter.Mnu_Del_dos.Checked = True

End Function

Public Function refresh_filters()
Cat_Dir = DskCenter.Mnu_cat_dir.Checked
Cat_RO = DskCenter.Mnu_Cat_RO.Checked
Cat_RO_Sys = DskCenter.Mnu_Cat_RO_SYS.Checked
Cat_Del = DskCenter.Mnu_Cat_Deleted.Checked
Cat_attics = DskCenter.Mnu_Cat_illegals.Checked
End Function

Public Function DispMsg(Message As String, Optional confirme As Boolean) As Integer
'vbOK    1   OK
'vbCancel    2   Annuler
'vbAbort 3   Abandonner
'vbRetry 4   Ressayer
'vbIgnore    5   Ignorer
'vbYes   6   Oui
'vbNo    7   Non
DispMsg = MsgBox(Message, vbOKCancel, "Delete it?")

End Function
Public Function Bloc_Hexa(ByVal Blocs As String) As String

If Asc(Mid(Blocs, 1, 1)) = &HFF Then Exit Function

Dim a, bloc_ass As Integer
            Bloc_Hexa = ""
            For a = 1 To 16 ' Convertion de chaque bloc en Hexa => HEX((bloc)n+1)
            bloc_ass = Asc(Mid(Blocs, a, 1))
            If a < 15 Then
                If (Len(Blocs) >= a + 1) And _
                (Computer = "MPM" Or Computer = "MSXCPM3") And _
                (Asc(Mid(Blocs, a, 1)) = &HFF) And _
                (Asc(Mid(Blocs, a + 1, 1)) = 0) Then
                
                Bloc_Hexa = Right(Bloc_Hexa, Len(Bloc_Hexa) - 1): Exit Function
                End If
            End If
            
            If bloc_ass <> 0 And Asc(Mid(Blocs, a, 1)) < &H10 Then Bloc_Hexa = Bloc_Hexa + ",0" + Hex(Asc(Mid(Blocs, a, 1)))
            If bloc_ass <> 0 And Asc(Mid(Blocs, a, 1)) >= &H10 Then Bloc_Hexa = Bloc_Hexa + "," + Hex(Asc(Mid(Blocs, a, 1)))
            Next a
If Len(Bloc_Hexa) = 0 Then Exit Function
Bloc_Hexa = Right(Bloc_Hexa, (Len(Bloc_Hexa) - 1))
End Function
Public Function Read_DSK_file(File_Name As String, adressage_blocs As String, Optional write_this As Boolean = False) As String

Dim offset_data, offset_piste, cpm_cat_offset As Single
Dim Data As String * 1024
Dim DirEntry As DirEntry
Dim Bloc_array(255), piste, ba, a, b, c As Integer
Dim File_Entry As File_Entry
Dim texte As String
Dim Item As ListItem



Read_DSK_file = ""
piste = 0
ba = 1

'type : "P01:01,02,03,04,05,06,07,08,09,0A,0B,0C,0D,0E,10,P02:01"...
'---- sect. : Blocs ... (16)                            sect.: Blocs ...(16)

a = 1

Do While a <= Len(adressage_blocs)

If Mid(adressage_blocs, a, 1) = "P" Then
piste = piste + 1

Bloc_array(ba) = Val("&h" & Mid(adressage_blocs, a + 1, 2))
Debug.Print "Track:"; Bloc_array(ba)

a = a + 4: ba = ba + 1
End If

Bloc_array(ba) = Val("&h" & Mid(adressage_blocs, a, 2))
ba = ba + 1
a = a + 3
Loop


'If file_name = "" Then Exit Sub


' attributs specifications
If UCase(GetFileAttrib(Long_Nom_fichier_selec)) = "PCN" Then
texte = read_cpc_disk(Long_Nom_fichier_selec, False, False, False, 0)
GoTo endreadfile
End If

'Binary tag
Select Case read_type(Long_Nom_fichier_selec, False)
Case "CPM", "CPC", "EXTENDED CPC"
texte = read_cpc_disk(Long_Nom_fichier_selec, False, False, False)

Case "?"
texte = read_cpc_disk(Long_Nom_fichier_selec, False, False, False, 0)

Case "NO$CPC40", "NO$CPC41", "NO$CPC42", "NO$CPC40!", "NO$CPC41!", "NO$CPC42!"
texte = read_cpc_disk(Long_Nom_fichier_selec, False, False, False, 2)

End Select

endreadfile:
' - End of offset scan.

Dim cpcn_name As String
cpcn_name = App_Path & "\" & TMP_Path & "\" & Left(Cut_Name(File_Name), Len(Cut_Name(File_Name)) - 4) & ".CPCn"


LiX1 = FreeFile
        Open cpcn_name For Binary Access Write As #LiX1
        Put #LiX1, 1, texte
        Close #LiX1

Read_DSK_file = ""

  Dim offset_blocs, offset_secteur As Single
  
View_ascii_text.info1.Enabled = True
View_ascii_text.info2.Enabled = True

DskCenter.init_info1

Lix = FreeFile
  Open cpcn_name For Binary Access Read As #Lix Len = 1024
  
If CMP_flag = False Then
  cpm_cat_offset = 1025
    offset_blocs = cpm_cat_offset + ((Bloc_array(2) - 1) * &H400)
  Else
  cpm_cat_offset = 12801
     offset_blocs = (cpm_cat_offset + ((Bloc_array(2) - 1) * &H200) / 2)
End If
  
 
  
Debug.Print ((Bloc_array(2) - 1) * &H400), offset_blocs, CMP_flag
 
Get #Lix, offset_blocs, File_Entry


View_ascii_text.info1.ListItems().Clear
Set Item = View_ascii_text.info1.ListItems.Add()
' if Text file, No header
If File_Entry.User > &H1C& Then
View_ascii_text.info2.Visible = False: Item.SubItems(4) = "ASCII"
View_ascii_text.Picture2.Visible = False
Item.text = "No header"
View_ascii_text.Texte1.Visible = True
View_ascii_text.View_hex.Visible = False
 GoTo txt_file
End If

Item.text = File_Entry.root
Item.SubItems(1) = File_Entry.ext
View_ascii_text.Picture2.Visible = True
' 0=basic, 1=protected basic, 2=binary,...
If File_Entry.File_type = 0 Then Item.SubItems(4) = "Basic"
If File_Entry.File_type = 1 Then Item.SubItems(4) = "Protect.Basic"
If File_Entry.File_type = 2 Then Item.SubItems(4) = "Binary"
If File_Entry.File_type > 2 Then Item.SubItems(4) = "???"


Item.SubItems(2) = File_Entry.User
Item.SubItems(3) = Hex(Asc(Mid(File_Entry.real_length, 1, 1))) + Hex(Asc(Mid(File_Entry.real_length, 2, 1))) + Hex(Asc(Mid(File_Entry.real_length, 3, 1)))

Item.SubItems(5) = Hex(File_Entry.checkSum)
Item.SubItems(6) = File_Entry.CPM_ext

View_ascii_text.info2.ListItems().Clear

Set Item = View_ascii_text.info2.ListItems().Add()
  
Item.text = File_Entry.Bloc_number
Item.SubItems(1) = File_Entry.length_Bloc
Item.SubItems(2) = File_Entry.first_bloc_flag
Item.SubItems(3) = File_Entry.Last_bloc_flag
Item.SubItems(4) = Hex(File_Entry.entry_Address)
Item.SubItems(5) = Hex(File_Entry.load_address)
Item.SubItems(6) = File_Entry.Sector_buffer

 View_ascii_text.Texte1.Visible = False
 View_ascii_text.View_hex.Visible = True
txt_file:

For b = 1 To ba Step 17

offset_piste = Bloc_array(b)
For c = 1 To 16
If Bloc_array(b + c) = "" Then Exit For

    
If CMP_flag = False Then
offset_data = cpm_cat_offset + ((Bloc_array(b + c) - 1) * &H400) ' + Bloc_array(B)
Else
offset_data = cpm_cat_offset + ((Bloc_array(b + c) - 1) * &H200) ' + Bloc_array(B)
End If

   
If Bloc_array(b + c) = 0 Then Exit For
  Get #Lix, offset_data, Data
  Read_DSK_file = Read_DSK_file + Data
 
 Next c
 Next b
  Close #Lix

If write_this = True Then
     LiX1 = FreeFile
        Open App_Path & "\" & Txt_Path & "\" & File_Name & ".TXT" For Binary Access Write As #LiX1
        Put #LiX1, , Read_DSK_file
        Close #LiX1
        MsgBox App_Path & "\" & Txt_Path & "\" & File_Name & ".TXT saved !", vbExclamation, "File Saved ..."
End If

load_view_hex Read_DSK_file, 1

On Error Resume Next
If File_Entry.User < 15 Then Read_DSK_file = Right(Read_DSK_file, Len(Read_DSK_file) - &H46)
If File_Entry.User > 15 And File_Entry.User <> 229 Then Read_DSK_file = Left(Read_DSK_file, InStr(1, Read_DSK_file, Chr(&H1A), vbBinaryCompare) - 1)


Kill cpcn_name

End Function

Public Function read_type_sna(Optional File_Name As String, Optional get_info As Boolean) As String
Dim taille_disk As Double


Dim SNA_Header As SNA_Header
Dim DirEntry As DirEntry
Dim Size As Single
Dim Track_Header As Track_Header
Dim Pas_de_cat As Byte

Lix = FreeFile
  
  Open File_Name For Binary Access Read As #Lix Len = Len(SNA_Header)
  Get #Lix, 1, SNA_Header
  Close #Lix


If Left(UCase(SNA_Header.SNA_Tag), 8) <> "MV - SNA" Then read_type_sna = "!!!": GoTo end_scan Else read_type_sna = "SNA"


If get_info = True Then

         DskCenter.Property_disk.Visible = False
         DskCenter.sna_info.Visible = True


 
DskCenter.SNA_text_info.text = "   " & SNA_Header.SNA_Tag & vbCrLf
Select Case SNA_Header.SNA_CPC_TYPE

Case 0
DskCenter.SNA_text_info.text = DskCenter.SNA_text_info.text + "   CPC 464 device." & vbCrLf
   
Case 1
DskCenter.SNA_text_info.text = DskCenter.SNA_text_info.text + "   CPC 664 device." & vbCrLf

Case 2
DskCenter.SNA_text_info.text = DskCenter.SNA_text_info.text + "   CPC 6128 device." & vbCrLf

Case 3
DskCenter.SNA_text_info.text = DskCenter.SNA_text_info.text + "   Unknown device." & Chr(10)

End Select

DskCenter.SNA_text_1.Caption = "Dump.:" & format(SNA_Header.SNA_memory_bump, "###000") & " Ko"

DskCenter.SNA_text_2.Caption = "Release:" & Str(SNA_Header.SNA_Version)

End If
  
end_scan:
 If read_type_sna = "!!!" Then DskCenter.SNA_text_info.text = Pc_Dsk_Format(File_Name)
  
 End Function
Sub read_snap_screen(SNA_File_name As String)

' ********************** BuGGy Star Show !!! *********************
' In progress : (for a long, long time !)
' - Binary Offset bug.
' - Overscan and screen start address ignored.
' - Set for Mode 1 only.
' - Sna_header start colors ignored.
' ****************************************************************


Dim SNA_Header As SNA_Header
Dim blt_CPC(32767) As blt_CPC


Lix = FreeFile
  
  Open SNA_File_name For Random Access Read As #Lix Len = Len(SNA_Header)
  Get #Lix, 1, SNA_Header
  Close #Lix

Dim pos, pos2 As Single

pos = &HC107&
pos2 = 1
Lix = FreeFile
Open SNA_File_name For Binary Access Read As #Lix

Do While EOF(Lix) = False

Get #Lix, pos, blt_CPC(pos2)

pos = pos + 1
pos2 = pos2 + 1
If pos = 16321 Then Exit Do
Loop

Close #Lix
  
Dim Ligne, d, raw, colonne, comp, sprite, offset_ligne As Integer
Dim val_4bit_1a4, val_4bit_5a8 As Double
Dim val_matrix, matrice_8bits As String
Dim xret As Long
Dim T As Variant

comp = 1
offset_ligne = 0

For d = 0 To 7
 For Ligne = 1 To 200 Step 8

 If offset_ligne = 8 Then offset_ligne = 0
  For colonne = 1 To 320 Step 80
  For raw = 1 To 80 Step 4
  
' Note (English) in French, a Byte is translated by "Octet" 8 bits
'                and a "bit" equal binary 0 or 1 like english word.
'
' mode 0 = 160x200x16 (15 colors +1 background)
' mode 1 = 320x200x4  (3 colors +1 background) 320 (80x4) 200 (25x8)
' bits:
' "1234 5678"  1-4 Pen 1   5-6 Pen 0  1-4 + 5-8 Pen 2
'
'
' mode 2 = 640x200x2  (1+1 background)
'
'      :address (byte) exemple: &hC000,255
'mode1 :1:2:3:4:5:6:7:8:
'       I       I
' disection de l'adresse cran 8 bits en 2x4 bits

 val_matrix = ConvBin(CDbl(blt_CPC(comp).col1), 8) ' bin en 8 bits
 val_4bit_1a4 = BinToDbl(Mid(val_matrix, 1, 4))
 val_4bit_5a8 = BinToDbl(Mid(val_matrix, 5, 8))
 
  ' sprite  0 couleur de fond - *
' If val_4bit_1a4 = 0 And val_4bit_5a8 = 0 Then
' For sprite = 0 To 8
'  If Mid(val_matrix, sprite + 1, 1) = "1" Then xret& = SetPixel(dskcenter.SNA_Snap_screen.hDC, colonne + sprite + raw, Ligne + d, vbBlack)
' Next
' End If
 
 'sprite pen 1 - jaune
' If val_4bit_5a8 = 0 And val_4bit_1a4 > 0 Then
'    For sprite = 0 To 3
 '   If Mid(val_matrix, sprite + 1, 1) = "1" Then xret& = SetPixel(dskcenter.SNA_Snap_screen.hDC, colonne + sprite + raw, Ligne + d, vbYellow)
'    Next sprite
'    GoTo fin_boucle
' End If
 
 'sprite pen 0 - bleu
' If val_4bit_1a4 = 0 And val_4bit_5a8 > 0 Then
'    For sprite = 0 To 3
'    If Mid(val_matrix, sprite + 5, 1) = "1" Then xret& = SetPixel(dskcenter.SNA_Snap_screen.hDC, colonne + sprite + raw, Ligne + d, vbBlue)
'   Next sprite
 '   GoTo fin_boucle
' End If
 
 'sprite pen 2 - rouge
'If val_4bit_1a4 > 0 And val_4bit_5a8 > 0 Then
 For sprite = 0 To 3
 If Mid(val_matrix, sprite + 1, 1) = "1" And Mid(val_matrix, sprite + 5, 1) = "1" Then xret& = SetPixel(DskCenter.SNA_Snap_screen.hdc, colonne + sprite + raw, Ligne + d, vbRed)
 If Mid(val_matrix, sprite + 1, 1) = "0" And Mid(val_matrix, sprite + 5, 1) = "1" Then xret& = SetPixel(DskCenter.SNA_Snap_screen.hdc, colonne + sprite + raw, Ligne + d, vbBlue)
 If Mid(val_matrix, sprite + 1, 1) = "1" And Mid(val_matrix, sprite + 5, 1) = "0" Then xret& = SetPixel(DskCenter.SNA_Snap_screen.hdc, colonne + sprite + raw, Ligne + d, vbYellow)
 If Mid(val_matrix, sprite + 1, 1) = "0" And Mid(val_matrix, sprite + 5, 0) = "0" Then xret& = SetPixel(DskCenter.SNA_Snap_screen.hdc, colonne + sprite + raw, Ligne + d, vbBlack)
 Next sprite
 GoTo fin_boucle
'End If
  
fin_boucle:
T = DoEvents()
comp = comp + 1
Next raw
Next colonne

offset_ligne = offset_ligne + 1

Next Ligne
Next d
 
end_scan:
End Sub

Public Function fixe_CPCEmuStruc(File_Name As String, Heads As String, nb_tracks As String, Track_size As String)

  If Val(nb_tracks) >= 255 Then Exit Function

Lix = FreeFile
  Open File_Name For Binary Access Write As #Lix

  Put #Lix, 49, CByte(Val(nb_tracks)) ' nb_track
  Put #Lix, 50, CByte(Val(Heads)) ' Heads
  Put #Lix, 51, CInt(Val(Track_size)) ' Tracks size
  
  Close #Lix
End Function

Public Function text_2_spec_ascii(import_text As String, Country As String) As String
Dim a As Single
Dim scan_char As String

text_2_spec_ascii = ""

a = 1

Select Case Country

Case "Fr"
            ' Text French filter "azerty" and specials chars.

        Do While a <= Len(import_text)
            scan_char = Mid(import_text, a, 1)

            Select Case scan_char

            Case "{"
                    scan_char = ""
            Case "}"
                    scan_char = ""
            Case "\"
                    scan_char = ""
            Case "@"
                    scan_char = ""
            Case Chr(8)
                    scan_char = ""
            Case "^"
            scan_char = Right(text_2_spec_ascii, 1)
            If scan_char = "a" Then text_2_spec_ascii = Left(text_2_spec_ascii, Len(text_2_spec_ascii) - 1) + "": scan_char = ""
            If scan_char = "e" Then text_2_spec_ascii = Left(text_2_spec_ascii, Len(text_2_spec_ascii) - 1) + "": scan_char = ""
            If scan_char = "i" Then text_2_spec_ascii = Left(text_2_spec_ascii, Len(text_2_spec_ascii) - 1) + "": scan_char = ""
            If scan_char = "o" Then text_2_spec_ascii = Left(text_2_spec_ascii, Len(text_2_spec_ascii) - 1) + "": scan_char = ""
            If scan_char = "u" Then text_2_spec_ascii = Left(text_2_spec_ascii, Len(text_2_spec_ascii) - 1) + "": scan_char = ""
            
            Case ""
            scan_char = Right(text_2_spec_ascii, 1)
            If scan_char = "e" Then text_2_spec_ascii = Left(text_2_spec_ascii, Len(text_2_spec_ascii) - 1) + "": scan_char = ""
            If scan_char = "i" Then text_2_spec_ascii = Left(text_2_spec_ascii, Len(text_2_spec_ascii) - 1) + "": scan_char = ""
            
            End Select
            
            text_2_spec_ascii = text_2_spec_ascii + scan_char

            a = a + 1
            
        Loop
         

Case "En" ' Equal to ascii Pc font

      ' Text English filter

        Do While a <= Len(import_text)
            scan_char = Mid(import_text, a, 1)

            Select Case scan_char

            Case "$"
                    scan_char = Chr(0)
            End Select
      
            text_2_spec_ascii = text_2_spec_ascii + scan_char

            a = a + 1

        Loop

Case "Du"
      
      ' Text Dutch filter

        Do While a <= Len(import_text)
            scan_char = Mid(import_text, a, 1)

            Select Case scan_char

            Case "{"
              scan_char = Chr(223)
            End Select
      
            text_2_spec_ascii = text_2_spec_ascii + scan_char

            a = a + 1

        Loop

End Select

End Function
Sub Create_New_Ini()

    Dim savelist As Long
    On Error Resume Next
    Open App_Path & "\Emulator_list.ini" For Output As #1
      Print #1, "; DskCenter.ini File  v0.08" & vbNewLine _
              ; "; Usage -> Path : Emulator path directory." & vbNewLine _
              ; ";          Command1 + [file] + Command2" & vbNewLine _
              ; ";" & vbNewLine _
              ; ";  Max. Count = 50 items." & vbNewLine _
              ; ";" & vbNewLine _
              ; vbNewLine _
              ; "[Count]" & vbNewLine _
              ; "Count = 1" & vbNewLine _
              ; "[Emulator_01]" & vbNewLine _
              ; "Name = Name of your favorit emulator." & vbNewLine _
              ; "Path = c:\path" & vbNewLine _
              ; "command1 = c:\path\Emulator.exe" & vbNewLine _
              ; "command2 = /Blabla /&Bla" & vbNewLine _
              ; "Comments = My best emulator" & vbNewLine _

     Close #1
End Sub
Sub Create_New_Tag()

    Dim savelist As Long
    On Error Resume Next
    Open App_Path & "\" & Tag_Path & "\ZipTag.ini" For Output As #1
      Print #1, "; ZipTag.ini File v0.07" & vbNewLine _
               ; "; ---------------------" & vbNewLine _
               ; "; Text files list      " & vbNewLine _
               ; ";" & vbNewLine _
               ; "Usage :" & vbNewLine _
               ; "Path to Tags directory and text file Name" & vbNewLine _
               ; "Max. Count=10 items." & vbNewLine _
               ; "ignore app. path : 'C:\DskCenter\Zip Tags'" & vbNewLine & vbNewLine _
               ; "[Count]" & vbNewLine _
               ; "Count = 1" & vbNewLine & vbNewLine _
               ; "[Tag_01]" & vbNewLine _
               ; "Name = DskCenter.txt" & vbNewLine

     Close #1
End Sub

Sub create_new_DSKCENTER_ini()
    
    Dim savelist As Long
    On Error Resume Next
    Open App_Path & "\DskCenter.ini" For Output As #1
Print #1, "; DskCenter.ini File" & vbNewLine _
          ; "; DskCenter.ini File v0.08" & vbNewLine _
          ; "; ------------------      " & vbNewLine _
          ; "; by XavSnap." & vbNewLine _
          ; ";" & vbNewLine _
          ; ";" & vbNewLine _
          ; ";" & vbNewLine & vbNewLine _
          ; "[Setup]" & vbNewLine _
          ; "Update = True" & vbNewLine _
          ; "All_Files=False" & vbNewLine _
          ; "Language=" & vbNewLine _
          ; "LastPath=C:\" & vbNewLine _
          ; "BackColor = 14540253" & vbNewLine _
          ; "ForeColor = 0" & vbNewLine _
          ; "Zipcolor = 12640511" & vbNewLine _
          ; "NoSplash=False" & vbNewLine _
          ; "[Favorite]" & vbNewLine _
          ; "Count = 1" & vbNewLine _
          ; "PathName1=C:\" & vbNewLine
Close #1

End Sub
Public Function save_Bin_2_Bmp(in_file_name As String, Out_file_name As String, Optional mode As Integer)
mode = 2
Dim Bmp_header As Bmp_header
Dim image As String

' mode 0 = 160x200x16 (15 colors +1 background)
Bmp_header.mode0 = "424DBE3E0000000000003E00000028000000A0000000C80000000100010000000000803E0000120B0000120B00000200000002000000FFFFFF0000000000"

' mode 1 = 320x200x4  (3 colors +1 background)
Bmp_header.mode1 = "424DBE3E0000000000003E0000002800000040010000C80000000100010000000000803E0000120B0000120B00000200000002000000FFFFFF0000000000"

' mode 2 = 640x200x2  (1 color +1 background)
Bmp_header.mode2 = "424DBE3E0000000000003E0000002800000080020000C80000000100010000000000803E0000120B0000120B00000200000002000000FFFFFF0000000000"

Dim a, n, X As Integer

LiX1 = FreeFile

Open in_file_name For Binary Access Read As #LiX1
Get #LiX1, &HC000 + &HC100, image
Close #LiX1

Lix = FreeFile
  
  Open Out_file_name For Binary Access Write As #Lix
Put #Lix, 1, Bmp_header.mode2 ' Write header
  
a = &HFF80
For n = 0 To 199
For X = 0 To 79
Put #Lix, , Chr(a + X)
Next X
a = a - &H800&
    If a < &HC000 Then a = a - 16304
Next n
Close #Lix
End Function
Public Function load_view_hex(text As String, start As Single)
   
   Dim Item As ListItem
   Dim offset_start As Single
   Dim cmp2, EndOfFile As Single
   cmp = 1
   offset_start = 1
   
   View_ascii_text.Text1 = format(Len(text) / 1000, "###0.000") & " Ko."
   View_ascii_text.Text2 = format(&H7F& + 1, "###0000") & " Bytes."

'If cmp > 32760 Then cmp = 32760
'EndOfFile = Len(text)

Do While cmp <= Len(text)
   '-----------------------------------------------
   'Add an item to the list box
        '-----------------------------------------------
            Set Item = View_ascii_text.View_hex.ListItems.Add()
        ' -----------------------------------------------
        ' Enter the value into the list box
        ' -----------------------------------------------
          Item.text = Left("00000", 5 - Len(Hex(cmp - 1))) & Hex(cmp - 1) & "-" & Left("00000", 5 - Len(Hex(cmp + 6))) & Hex(cmp + 6)
          cmp2 = 1
          
Do While Mid(text, (cmp + cmp2) - 1, 1) <> "" And cmp2 < 9

 If Asc(Mid(text, cmp + cmp2 - 1, 1)) < &H10 Then
 Item.SubItems(cmp2) = "0" & Hex(Asc(Mid(text, cmp + cmp2 - 1, 1)))
 Else
 Item.SubItems(cmp2) = Hex(Asc(Mid(text, cmp + cmp2 - 1, 1)))
 End If
 Item.SubItems(cmp2 + 9) = Mid(text, cmp + cmp2 - 1, 1)
 
 cmp2 = cmp2 + 1
Loop

      cmp = cmp + 8
     
     Loop
      
End Function
Public Function open_zip_files(Zip_FileName As String)
Dim myzip As New Unzip
Dim outpath As String


Current_ZipName = Zip_FileName



If Comment_switch = True Then
init_Zip_Info (Current_ZipName)
DskCenter.Zip_Info.Visible = True
Else
DskCenter.Zip_Info.Visible = False
End If


myzip.ExtractDir = Tmp_App_Path
myzip.Unzip Zip_FileName, Tmp_App_Path
TmpFile = True


'Get CRC32_list
CRC32_List = Check_CRC32(Current_ZipName)

'Debug.Print myzip.GetLastMessage
End Function
Public Function Save_zip_files(Zip_FileName As String)

Refresh_ZIP32

On Error GoTo err

If DskCenter.Liste_DSK.SelectedItem Is Nothing Then Exit Function
If Zip_FileName <> "" Then SetAttr Zip_FileName, 0 Else Exit Function
    
If (GetAttr(Zip_FileName) And 2) Or (GetAttr(Zip_FileName) And 1) Then GoTo Jump_RO

Dim outpath As String
Dim myname As String
 
 myname = Dir(Tmp_App_Path & "\*.*", 39)

cmp = 0
Do While myname <> ""
zZipFileNames.zFiles(cmp) = Tmp_App_Path & "\" & myname & Chr(0)
Debug.Print "files : " & zZipFileNames.zFiles(cmp)
cmp = cmp + 1
myname = Dir
Loop

' ********************************************************************

'  Refesh comments.
' If Comment_switch Then zComment = 1 Else zComment = 0
'
' Can't hang the zip comment refresh !
' first zip check erase existing comments ...
' This comment must be rewrote to the new zipped file.
' In case of zComment = 0, comment = null char
' (zip Check is requiered due to an OI error in case of cruncated zip file
'   but repear option delete the existing comment!)

zComment = 1
'  Zip & Clean Temp directory.
'  refresh changed files.

' Use windows Temp dir in case of zip32 crash
zTempDir = GetTmpDir & Chr(0)
zJunkDir = 1 ' don't save path names
zRootDir = TMP_Path & Chr(0)

' Zip files
zZipInfo = DskCenter.Zip_Info_Txt.text & Chr(0)
zArgc = cmp           ' Number Of Elements Of mynames Array
zZipFileName = Zip_FileName & Chr(0)
retcode = VBZip32

' Zipped!

Debug.Print retcode

DoEvents
DskCenter.StatusBar1.Panels(1).text = Cut_o_arg(Right(retcode, Len(retcode) - 1))
' ********************************************************************

Jump_RO: ' Don't reZip
TmpFile = False
Refresh_ZIP32

Exit Function

err:
Debug.Print "ZIP SAVE ERROR:" & err.description
TmpFile = False
Refresh_ZIP32


End Function

Public Sub init_Zip_Info(File_Name As String)

If Comment_switch = True Then
DskCenter.Image7.Picture = DskCenter.ImageList_msk.ListImages().Item("comment_on").Picture
DskCenter.Zip_Info_Txt.Enabled = True
DskCenter.Zip_Info_Txt.BackColor = 8454143
'If GetFileAttrib(File_Name) = "ZIP" Then DskCenter.Zip_Info_Txt.text = Retrive_Zip_comment(Current_ZipName)
Else
DskCenter.Image7.Picture = DskCenter.ImageList_msk.ListImages().Item("comment_off").Picture
DskCenter.Zip_Info_Txt.Enabled = False
DskCenter.Zip_Info_Txt.BackColor = 12632256
End If
End Sub


Public Sub get_web_site(Go_to As String)
Dim ret As Long
    'The API that allows me to open the browser
    'in shell mode is on the modShell Module.
    Call NonBottom(DskCenter)
    
     DskCenter.TrayControl1.SendToTray
     BlnInTray = True
     
    On Error GoTo err
pShell Go_to
 
Exit Sub
err:
If MsgBox("Web site no found !" & vbCrLf & "Get ~" & Go_to & "~ to link Home Page.", vbCritical, "Link not found !") = vbOK Then Call NonTop(DskCenter): Call NonTop(About): Exit Sub

End Sub
Public Sub get_help(Lang_tag As String)

    'The API that allows me to open the browser
    'in shell mode is on the modShell Module.
    
      DskCenter.TrayControl1.SendToTray
      BlnInTray = True
      
    On Error GoTo err
    
pShell App_Path & "\help\index_" & Lang_tag & ".htm"
Exit Sub
err:
If MsgBox("Web site no found !" & vbCrLf & "Get ~http://dskcenter.free.fr/index.html~ to link Home Page.", vbCritical, "Link not found !") = vbOK Then Call NonTop(DskCenter): Call NonTop(About): Exit Sub
    
End Sub
Public Function dsk_mapping(adressage_blocs As String, File_Len As String, Color As Integer, File_Name As String)


Dim Lst As String
Dim a, ba As Integer
Dim Bloc_array(0 To 300) As Integer

'type : "P01:01,02,03,04,05,06,07,08,09,0A,0B,0C,0D,0E,10,P02:01"...
'---- sect. : Blocs ... (16)                            sect.: Blocs ...(16)


'
''For a = 0 To 249
'map_image.Label1(a).BackColor = &H8000000F
''Next

a = 1
ba = 1

   map_image.Show
   map_image.Map_list.ListItems.Add , , File_Name
  map_image.Map_list.ListItems.Item(map_image.Map_list.ListItems.Count).SubItems(1) = File_Len
  map_image.Map_list.ListItems.Item(map_image.Map_list.ListItems.Count).SubItems(2) = ((Color * 255) \ 64) * 5
   
Do While a <= Len(adressage_blocs)

' Blocs enumeration.
    
    If Mid(adressage_blocs, a, 1) <> "P" Then
      Bloc_array(ba) = Val("&h" & Mid(adressage_blocs, a, 2))
            
       ' Bloc out of range >249 (may be an opcode crash)
       If Bloc_array(ba) > 300 Then Bloc_array(ba) = 300
  
  If map(Bloc_array(ba)).Alloc_Bloc > 0 Then

        map_image.Label1(Bloc_array(ba)).BorderStyle = 0
       Debug.Print "Bloc "; Bloc_array(ba); " already assinged !"
        map_image.Map_list.ListItems.Item(map_image.Map_list.ListItems.Count).SmallIcon = "FAA"
        faa = faa + 1
        
      Else
     
        map(Bloc_array(ba)).Alloc_Bloc = Bloc_array(ba)   ' Bloc content.
        map(Bloc_array(ba)).Numb_file = Color        ' Color ID file (#file).
        map_image.Map_list.ListItems.Item(map_image.Map_list.ListItems.Count).SmallIcon = "V"
      blocs_Ok = blocs_Ok + 1
   End If

   Dim file_color As Integer
   
       file_color = ((Color * 255) \ 64) * 5

        map_image.Label1(Bloc_array(ba)).BackColor = file_color * (256 \ 64)
        map_image.Label1(Bloc_array(ba)).ToolTipText = "Bloc #" & Str(Bloc_array(ba)) & ": " & File_Name
     
   ba = ba + 1
    Else: a = a + 1
    End If

a = a + 3
Loop
    
End Function
 
Public Sub New_DSK(Main_header_info As d_header, Track_Header_Info As Track_Header, File_Name As String)

Dim a As Integer
Dim b As Integer

Dim Sub_track_info As Sub_track_info
Dim Data As String
Dim Cnt_Header As Integer
'
' Header info -> imported info
'   Main_header_info. tag
'   Main_header_info. nbof_tracks
'   Main_header_info. nbof_heads
'   Main_header_info.tracksize
'   Main_header_info.unused
'
' Track info -> imported info
'  Track_Header_Info.Tag_string ' "Track-Info\r\n"
'  Track_Header_Info.Track_number       ' Track number (0 to number of tracks-1)
'  Track_Header_Info.Head_number        ' Head Number(0 Or 1)
'  Track_Header_Info.BPS                ' BPS (bytes per sector) (2 for 0x200 bytes)
'  Track_Header_Info.SPT                ' SPT (sectors per track) (9, at the most 18)
'  Track_Header_Info.GAP3 As Byte       ' GAP#3 format (gap for formatting; 0x4E)
'  Track_Header_Info.Filler As Byte     ' Filling byte (filling byte for formatting; 0xE5)


 Track_Header_Info.Track_number = 0      ' Track number (0 to number of tracks-1)

Lix = FreeFile
Data = SPChar(Main_header_info.tracksize - &H100, Chr(Track_Header_Info.Filler))
If File_Name = "" Then Exit Sub
  Open File_Name For Binary Access Write As #Lix
Put #Lix, 1, Main_header_info ' Write Main header
  

For a = 0 To Main_header_info.nbof_tracks - 1
Track_Header_Info.Track_number = a      ' Track number (0 to number of tracks-1)
Put #Lix, , Track_Header_Info

Cnt_Header = &H18
For b = 0 To Track_Header_Info.SPT - 1
Sub_track_info.Track_nb = a
Sub_track_info.Head_nb = CByte(Track_Header_Info.Head_number)
Sub_track_info.Sector_nb = CByte(b + 193)
Sub_track_info.sector_size = CByte(Val(Track_Header_Info.BPS))
Sub_track_info.Error_1 = CByte(Val(Blank_dsk.Text6.text))
Sub_track_info.Error_2 = CByte(Val(Blank_dsk.Text8.text))
Sub_track_info.Empty = SPChar(2, Chr(0))

Put #Lix, , Sub_track_info
Cnt_Header = Cnt_Header + 8


Next b
' write end of Header
Put #Lix, , SPChar(&H100 - Cnt_Header, Chr(0))

' Write sector data
Put #Lix, , Data

Next a
Close #Lix
End Sub
Public Sub move_file_to(File As String, path As String)
Dim ret$
If Cut_Name(File) = "" Then Exit Sub
'On Error GoTo err_h
If FileExists(path) = False Then
 If MsgBox("Can't find this System directory ! " & vbCrLf & "Create this directory ?" & vbCrLf & path, vbOKCancel, " Directory is missing !") = vbOK Then MkDir (path) Else Exit Sub
End If
If FileExists(path & "\" & Cut_Name(File)) = True Then
ret = MsgBox("File already exist !" & vbCrLf & path & "\" & Cut_Name(File) & vbCrLf & "Delete it ?", vbOKCancel, " File already existe !")
If ret = vbCancel Then Exit Sub Else Kill (path & "\" & Cut_Name(File))
End If

TmpChar = path & "\" & Cut_Name(Long_Nom_fichier_selec)

' Long name problems with Windows 98!
On Error Resume Next
Name Long_Nom_fichier_selec As TmpChar
Exit Sub
err_h:

End Sub

Public Function extract_date(intDate As Integer, IntTime As Integer) As String
Dim BinDate As String
Dim BinTime, MyTime, mm As String
Dim ValDay, ValMounth, ValYear As Integer
Dim ValHoure, ValMin, ValSec As Integer

BinDate = ConvBin(CLng(intDate), 16)
BinTime = ConvBin(CLng(IntTime), 16)

ValDay = Val(BinToDbl(Right(BinDate, 5)))
ValMounth = Val(BinToDbl(Mid(BinDate, 8, 4)))
ValYear = Val(BinToDbl(Left(BinDate, 7)))


ValHoure = Val(BinToDbl(Left(BinTime, 5)))
ValMin = Val(BinToDbl(Mid(BinTime, 6, 6)))
ValSec = Val(BinToDbl(Right(BinTime, 5))) * 2


Select Case ValMounth
Case 1
mm = "Jan."
Case 2
mm = "Feb."
Case 3
mm = "Mar."
Case 4
mm = "Apr."
Case 5
mm = "May"
Case 6
mm = "Jun."
Case 7
mm = "Jul."
Case 8
mm = "Aug."
Case 9
mm = "Sep."
Case 10
mm = "Oct."
Case 11
mm = "Nov."
Case 12
mm = "Dec."
End Select

MyTime = format(ValHoure, "##0:") & format(ValMin, "##00:") & format(ValSec, "##00")

Dim tmpval As String
tmpval = format(ValDay, "##00") & "-" & mm & "-" & format(ValYear + 1980, "####0000") & " " & MyTime
If ValDay = 0 Then extract_date = "Unknown." Else extract_date = tmpval

End Function
Public Function Chk_file_integrity(Name As String) As String

' ASCII char. < 32 send "BAD"
' Excludes Dos chars send "?"
' Warning ! Euro & local charset send "SPECHAR" arguments.
' File ok send "OK"

Dim tmpstr As String
Dim cmpstr As Integer
cmpstr = 0

Do While cmpstr < Len(Name)
cmpstr = cmpstr + 1
tmpstr = Asc(Mid(Name, cmpstr, 1))
If tmpstr < 32 Then Chk_file_integrity = "BAD": Exit Do
If tmpstr = "\" Or tmpstr = "/" Or tmpstr = ":" Or tmpstr = "*" Or tmpstr = "?" Or tmpstr = Chr(34) Or tmpstr = "<" Or tmpstr = ">" Or tmpstr = "|" Then Chk_file_integrity = "?": Exit Do
If tmpstr > 152 Then Chk_file_integrity = "SPECHAR": Exit Do
Loop
If InStr(1, Name, "\") = 0 And InStr(1, Name, "/") = 0 And InStr(1, Name, ":") = 0 And InStr(1, Name, "*") = 0 And InStr(1, Name, "?") = 0 And InStr(1, Name, Chr(34)) = 0 And InStr(1, Name, "<") = 0 And InStr(1, Name, ">") = 0 And InStr(1, Name, "|") = 0 Then
    If cmpstr = Len(Name) And Chk_file_integrity <> "?" Then
    Chk_file_integrity = "OK"
    End If
Else
Chk_file_integrity = "BAD"
End If

End Function
Public Sub Scan_Dos_Directorys(Long_Nom_fichier_selec As String, Dsk_sys_tag As String)

Dim a As Integer
' Init tree
  DskCenter.PC_TreeView.Nodes.Clear
' Read Root directory.

Read_Cat_Dos Long_Nom_fichier_selec, Dsk_sys_tag
Debug.Print enum_Folders

If enum_Folders = 0 Then Exit Sub

Exit Sub

' Retrive sub-folders level 2.
For a = 1 To enum_Folders
    Debug.Print "Bloc Start  "; Folders(a).Start_cluster
    If Left(Folders(a).Parent, 1) <> Chr(&HE5) Then
    Debug.Print "Parent :"; Folders(a).Name
    Read_Cat_Dos Long_Nom_fichier_selec, , , , , , False, Folders(a).Start_cluster, Folders(a).Name
    End If
Next

End Sub
Public Function get_mess_system(File_Name) As String
Dim Mess_tag As Dsk_Mess_tag
On Error GoTo err_hand
Lix = FreeFile
Open File_Name For Random Access Read As #Lix Len = Len(Mess_tag)
    Get #Lix, 1, Mess_tag
Close #Lix

cmp = 0
Do While Not Mess_id_disk(cmp + 1).Id_System = "END"
cmp = cmp + 1
If Mess_tag.description_tag = Mess_id_disk(cmp).Id_System Then get_mess_system = " " & Mess_id_disk(cmp).description: Exit Function

Loop
err_hand:
get_mess_system = " Mess's tag corrupt" & vbCrLf & " or uncharted."
End Function
' Check Apple compatibilty :
 Public Sub os_info_Apple(Nom_fichier As String)

TmpInt = FileLen(Nom_fichier)

Select Case TmpInt

 Case 114688
 DskCenter.info_dsk_1.text = " Apple Boot sector " & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text + " SD 3.5' (112Kb) Format."
 
 Case 143360
 DskCenter.info_dsk_1.text = " Apple II Boot sector " & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text + " Dos 3.3 Format(140Kb)."

 Case 232960
 DskCenter.info_dsk_1.text = " Apple Boot sector " & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text + " Nibbles Format."
  
  Case 819200
 DskCenter.info_dsk_1.text = " Apple MAC Boot sector " & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text + " DD 3.5' (800Kb) Format."
 

 Case Else
  DskCenter.info_dsk_1.text = " Apple Boot sector " & vbCrLf
  DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text + Pc_Dsk_Format(Nom_fichier)
 TmpInt = 0
 End Select
 
 End Sub
  
Public Sub os_info_PRODOS(Nom_fichier As String)

TmpInt = FileLen(Nom_fichier)
Select Case TmpInt

 Case 114688
 DskCenter.info_dsk_1.text = " Apple ProDos Boot sector " & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text + "SD 3.5' (112Kb) Format."
 
 Case 143360
 DskCenter.info_dsk_1.text = " Apple ProDos Boot sector " & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text + " Dos Order Format."

 Case 232960
 DskCenter.info_dsk_1.text = " Apple ProDos Boot sector " & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text + " Nibbles Format."
  
  Case 819200
 DskCenter.info_dsk_1.text = " Apple ProDos Boot sector " & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text + " DD 3.5' (800Kb) Format."

 Case Else
  DskCenter.info_dsk_1.text = " Apple ProDos Boot sector " & vbCrLf
  DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text + Pc_Dsk_Format(Nom_fichier)
 TmpInt = 0
 End Select
 
 End Sub

 
Public Sub Dos_len(Nom_fichier As String)
TmpInt = FileLen(Nom_fichier)

If TmpInt < Bootstrap_Image_len Then
Lix = FreeFile
Open Nom_fichier For Binary Access Write As #Lix
TmpChar = Space$(Bootstrap_Image_len - TmpInt)
Put #Lix, TmpInt + 1, TmpChar
Close #Lix
End If

End Sub



Public Sub Scan_TRSDOS_Directorys(Long_Nom_fichier_selec As String, Dsk_sys_tag As String)

Dim a As Integer
' Init tree
  DskCenter.C64.ListItems().Clear
Call DskCenter.Active_TRSDos
  
' Read Root directory.
Read_Cat_TRSDOS Long_Nom_fichier_selec, Dsk_sys_tag
End Sub
Public Sub Scan_Ti99_Directorys(Long_Nom_fichier_selec As String, Dsk_sys_tag As String)

Dim a As Integer
' Init tree
  DskCenter.C64.ListItems().Clear
Call DskCenter.Active_Ti99
  
' Read Root directory.
Read_Cat_Ti99 Long_Nom_fichier_selec
End Sub


Sub init_c64()
Dim clmhdr2 As ColumnHeader

    DskCenter.C64.ColumnHeaders.Clear
    '-----------------------------------------------------
    ' add columns to listview control
    '-----------------------------------------------------
    Set clmhdr2 = DskCenter.C64.ColumnHeaders.Add()
    clmhdr2.text = "Name:"
    clmhdr2.Width = 2 * (DskCenter.C64.Width / 3)
       
    Set clmhdr2 = DskCenter.C64.ColumnHeaders.Add()
    clmhdr2.text = "Length:"
    clmhdr2.Width = (DskCenter.C64.Width / 3)
    clmhdr2.Alignment = lvwColumnLeft
    
    Set clmhdr2 = DskCenter.C64.ColumnHeaders.Add()
    clmhdr2.text = "Attr."
    clmhdr2.Width = 1000
    clmhdr2.Alignment = lvwColumnLeft
  
    Set clmhdr2 = DskCenter.C64.ColumnHeaders.Add()
    clmhdr2.text = "User"
    clmhdr2.Width = 700
    clmhdr2.Alignment = lvwColumnLeft
 
End Sub
Function Sp_ascii(ASCII_file_name As String) As String

' Ascii Specials char. for Commodore c64*/128 (ASCII ART)

'tmpval = Len(ASCII_file_name)
' C0 = "="
' DF = "\"
' A9 = "/"
' A3 = ""
' B1 = ""
' DD = "|"
' AB = "L"
' BD = ""
' A4 = "_"
' EA = ""
' DB = "+"
Sp_ascii = ASCII_file_name
End Function

' Check Hd compatibility For the Original IBM PC-XT technical data book driver
' WD1004A-WXI device :
 Public Sub Info_CHD(Nom_fichier As String)
 DskCenter.info_dsk_1.Enabled = True
 DskCenter.info_dsk_1.text = " XT Hard Disk. " & vbCrLf & "  WD1004a-WXI compatible. "
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub
' Check HD compatibilty for Standard HD devices:
 Public Sub Info_HD(Nom_fichier As String)
 DskCenter.info_dsk_1.Enabled = True
 DskCenter.info_dsk_1.text = " AT Hard disk. " & vbCrLf & "  Standard Hard Disk driver."
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub
 
 Public Function get_offset() As Integer
 

 ' attributs specifications
If UCase(GetFileAttrib(Long_Nom_fichier_selec)) = "PCN" Then
get_offset = -512
GoTo endreadfile
End If

'Binary tag
Select Case read_type(Long_Nom_fichier_selec, False)
Case "CPM", "CPC", "EXTENDED CPC"
get_offset = 0

Case "NO$CPC40", "NO$CPC41", "NO$CPC42", "NO$CPC40!", "NO$CPC41!", "NO$CPC42!"
get_offset = -510
End Select
endreadfile:
' - End of offset scan.

 End Function

Public Sub Convert2DSK(File_Name As String)
If FileExists(File_Name) <> True Then Exit Sub
Dim a As Integer
Dim b As Integer

Dim Sub_track_info As Sub_track_info
Dim Track_Header_Info As Track_Header
Dim Main_header_info As d_header

Dim Cnt_Header As Integer
'
' Header info -> imported info
   Main_header_info.Tag = "MV - CPCEMU Disk-File" & vbCrLf & "DskCenter" & SPChar(16, Chr(0))
   Main_header_info.nbof_tracks = 42
   Main_header_info.nbof_heads = 0
   Main_header_info.tracksize = 4608
   Main_header_info.unused = SPChar(&HCC, Chr(0))
   
'   Main_header_info.unused
'
' Track info -> imported info
  Track_Header_Info.Tag_string = "Track-Info" & vbCrLf & Chr(0)
  Track_Header_Info.Head_number = 0      ' Head Number(0 Or 1)
  Track_Header_Info.BPS = 2               ' BPS (bytes per sector) (2 for 0x200 bytes)
  Track_Header_Info.SPT = 9              ' SPT (sectors per track) (9, at the most 18)
  Track_Header_Info.GAP3 = &H4E      ' GAP#3 format (gap for formatting; 0x4E)
  Track_Header_Info.Filler = &HE5    ' Filling byte (filling byte for formatting; 0xE5)
  


Dim nb_tracks  As Integer
Dim offcpn As Single

nb_tracks = FileLen(File_Name) \ 4608
If (FileLen(File_Name) / 4608) - nb_tracks > 0 Then nb_tracks = nb_tracks + 1
 
 Main_header_info.nbof_tracks = nb_tracks
 
offcpn = 1
  LiX1 = FreeFile
  Open File_Name For Binary Access Read As #LiX1 Len = 4608
  

If File_Name = "" Then Exit Sub

  Lix = FreeFile
  Open File_Name & ".DSK" For Binary Access Write As #Lix
Put #Lix, 1, Main_header_info ' Write Main header

For a = 0 To nb_tracks - 1
Track_Header_Info.Track_number = a      ' Track number (0 to number of tracks-1)
Put #Lix, , Track_Header_Info

Cnt_Header = &H18
For b = 0 To Track_Header_Info.SPT - 1
Sub_track_info.Track_nb = a
Sub_track_info.Head_nb = 0
Sub_track_info.Sector_nb = CByte(b + 193)
Sub_track_info.sector_size = CByte(Val(Track_Header_Info.BPS))
Sub_track_info.Error_1 = 0: '
Sub_track_info.Error_2 = 0: '
Sub_track_info.Empty = SPChar(2, Chr(0))


Put #Lix, , Sub_track_info
Cnt_Header = Cnt_Header + 8


Next b
' write end of Header
Put #Lix, , SPChar(&H100 - Cnt_Header, Chr(0))


Get #LiX1, offcpn, Data_Track
offcpn = offcpn + 4608

' Write sector data
Put #Lix, , Data_Track

Next a
Close #Lix
End Sub
Public Sub Convert2Mess(File_Name As String, Target_file As String, Mess_tag As String, Optional Nb_Side As Integer = 0, Optional nb_tracks As Integer = 40, Optional nb_sectors As Integer = 9, Optional Data_Size As Integer = 415)

Dim a As Integer
Dim b As Integer

Dim Track_Header_Info As Mess_Track_Entry
Dim Data_Track_Mess As String

Dim Cnt_Header As Integer
'
' Header info -> imported info
   Track_Header_Info.Separator_1 = &HE5
   Track_Header_Info.Separator_2 = Chr(&H0) & Chr(&HE5) & Chr(&HE5)
   Track_Header_Info.Separator_3 = Chr(&H0) & Chr(&HE5) & Chr(&HE5)
   Track_Header_Info.Separator_4 = Chr(&H0) & Chr(&HE5) & Chr(&HE5)
   
   Track_Header_Info.ID_Tag = Left(Mess_tag, 4) & "            "
   Track_Header_Info.Side = "SIDE        0   "
   Track_Header_Info.Head_id = "HEAD ID     0"
   
   
   Track_Header_Info.Track_nb = "TRACK       X"
   Track_Header_Info.Sector = "SECTOR      X   "
   Track_Header_Info.Sector_id = "SECTOR ID   X"

 
  

Dim offcpn As Single


' Test size of data file to set disk tracks.
'Nb_tracks = FileLen(file_name) \ 415
'If (FileLen(file_name) / 415) - nb_tracks > 0 Then nb_tracks = nb_tracks + 1

'  ******************************************
'' Warning : Extra-filler set to &h00 -> &HE5
'' use SPChar(empty string, Chr(&HE5))
'  ******************************************


' Seek data to 1
offcpn = 1
  
  LiX1 = FreeFile
  
  'Open data file
  Open File_Name For Binary Access Read As #LiX1 Len = Data_Size
  

If File_Name = "" Then Exit Sub

  Lix = FreeFile
  Open Target_file For Binary Access Write As #Lix

For a = 0 To nb_tracks - 1

For b = 0 To nb_sectors - 1

Data_Track_Mess = Space$(Data_Size)

Get #LiX1, offcpn, Data_Track_Mess
offcpn = offcpn + Data_Size

If a < 10 Then Track_Header_Info.Track_nb = "TRACK       " & a Else Track_Header_Info.Track_nb = "TRACK      " & a
Track_Header_Info.Sector_id = "SECTOR ID   " & b
Track_Header_Info.Sector = "SECTOR      " & b & "   "

Put #Lix, , Track_Header_Info
Put #Lix, , Data_Track_Mess
Next b
Next a
Close #Lix
Close #LiX1
End Sub
Sub Sp_Name(Fore As Long, Back As Long, node As String)

  DskCenter.PC_TreeView.Nodes.Item(node).BackColor = Back
  DskCenter.PC_TreeView.Nodes.Item(node).Bold = True
  DskCenter.PC_TreeView.Nodes.Item(node).ForeColor = Fore

End Sub

Sub Conv_nocpc2Raw(File_Name As String)
Dim f1 As Single
Lix = FreeFile

Open File_Name & "_Raw.CPCn" For Binary Access Write As #Lix
        
        Lix2 = FreeFile
        f1 = FileLen(File_Name) - 2
        Open File_Name For Binary Access Read As #Lix2
        TmpChar = Space$(f1)
        
        Get #Lix2, 3, TmpChar
        Close #Lix2
        
Put #Lix, , TmpChar

 Close #Lix
End Sub

Sub Conv_ATR2XFD(File_Name As String)
Dim f1 As Single
Lix = FreeFile

Open File_Name & "_Raw.XFD" For Binary Access Write As #Lix
        
        Lix2 = FreeFile
        f1 = FileLen(File_Name) - 16
        Open File_Name For Binary Access Read As #Lix2
        TmpChar = Space$(f1)
        
        Get #Lix2, 17, TmpChar
        Close #Lix2
        
Put #Lix, , TmpChar

 Close #Lix
End Sub

Function decode_fat12(offset As Fat12) As Fat12
Dim fat_bin As String

decode_fat12.In_B1 = offset.In_B1
decode_fat12.In_B2 = offset.In_B2
decode_fat12.In_B3 = offset.In_B3

fat_bin = ConvBin(CLng(offset.In_B2), 8)
decode_fat12.Out_B1 = CInt(BinToDbl(Mid(fat_bin, 5, 4) + ConvBin(CLng(offset.In_B1), 8)))
decode_fat12.Out_B2 = CInt(BinToDbl(ConvBin(CLng(offset.In_B3), 8) + Mid(fat_bin, 1, 4)))

End Function

Function get_bloc_fat12(id_bloc As Single) As Fat12


End Function

Sub Read_FAT12_all(File_Name As String, Offset_FAT As Single)
Dim Fat_data As Fat12
Dim counter_offset As Single
Dim a As Single
Dim flag_null As Boolean

Erase Fat12_array()

a = 1
counter_offset = Offset_FAT
Lix = FreeFile

Open File_Name For Random Access Read As #Lix
  
Do Until counter_offset > 1538

Get #Lix, counter_offset, Fat_data
Fat12_array(a) = decode_fat12(Fat_data).Out_B1
Fat12_array(a + 1) = decode_fat12(Fat_data).Out_B2
If Fat12_array(a) = 0 And Fat12_array(a + 1) = 0 Then Exit Do
a = a + 2

counter_offset = counter_offset + 3
Loop
 Close #Lix
 
 Debug.Print "Fat#"; a
End Sub

Function Read_FAT12(File_Name As String, Offset_FAT As Single, Nb_bloc As Integer) As Integer
Dim Fat_data As Fat12
Dim a, offset As Single
a = 1

Lix = FreeFile
Open File_Name For Binary Access Read As #Lix Len = Len(Fat_data)
'Nb_bloc = Nb_bloc - 1 '' &h55;&hAA;&h0F Fat header

'offset impaire
If (Nb_bloc / 2) - (Nb_bloc \ 2) > 0 Then

        Offset_FAT = Offset_FAT + 3 * (Nb_bloc / 2)
        
        Get #Lix, Offset_FAT, Fat_data
        
        Debug.Print Offset_FAT
        Debug.Print "IFat#1="; Fat_data.In_B1
        Debug.Print "IFat#2="; Fat_data.In_B2
        Debug.Print "IFat#3="; Fat_data.In_B3
 
        Read_FAT12 = decode_fat12(Fat_data).Out_B2
        
        Else

'offset paire

        Offset_FAT = Offset_FAT + (3 * (Nb_bloc / 2))
        
        Get #Lix, Offset_FAT, Fat_data
        
        Debug.Print Offset_FAT
        Debug.Print "PFat#1="; Fat_data.In_B1
        Debug.Print "PFat#2="; Fat_data.In_B2
        Debug.Print "PFat#3="; Fat_data.In_B3
        Read_FAT12 = decode_fat12(Fat_data).Out_B1
        
        
End If
  
 Close #Lix
 Debug.Print "Fat#"; Read_FAT12

End Function


Public Sub Make_Blank_raw(Target_file As String, Optional Nb_Side As Integer = 0, Optional nb_tracks As Integer = 40, Optional nb_sectors As Integer = 9, Optional Data_Size As Integer = 415)

Dim a, b, c As Integer
Dim Data_Track As String

  
  Lix = FreeFile
  Open Target_file For Binary Access Write As #Lix
  
For c = 0 To Nb_Side
For a = 0 To nb_tracks - 1
    For b = 0 To nb_sectors - 1
    
    Data_Track = SPChar(Data_Size, Chr(&HE5))
    
    Put #Lix, , Data_Track
    Next b
Next a
Next c

Close #Lix
End Sub

Public Function AmigaDos_DATE(days As Long) As String
 Dim ye, mo As Integer
 Dim nd, ndf, m As Integer
 Dim jm
 Dim mydate As Variant
 
 jm = Array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)

'* 0 = 1 Jan 1978,  6988 = 18 feb 1997 */
'days = 6988



ye = 1978

'******** year ********

If IsLeapYear(ye) Then
        ndf = 366
    Else
        ndf = 365
End If

Do While days >= ndf
        
     If IsLeapYear(ye) Then
            nd = 366
        Else
            nd = 365
     End If
        
  days = days - nd
  ye = ye + 1
Loop


'********* month ********
m = 1
    
If IsLeapYear(ye) Then jm(2) = 29 Else jm(2) = 28
     
Do While days >= jm(m - 1)
         days = days - jm(m - 1)
         m = m + 1
Loop
    
    
AmigaDos_DATE = " -" & days + 1 & "/" & Month(m) & "/" & ye & "-"

End Function

Sub Trim_file(File_Name_IN As String, File_Name_OUT As String, offset As Single)
Dim f1 As Long
Lix = FreeFile
Dim File_Name, d_header As String
On Error GoTo errhandler

Open File_Name_OUT For Binary Access Write As #Lix
        
        Lix2 = FreeFile
       
        f1 = FileLen(File_Name_IN) - offset + 1
        
        Open File_Name_IN For Binary Access Read As #Lix2
        d_header = Space$(f1)
        Get #Lix2, offset, d_header
        Close #Lix2
        
Put #Lix, , d_header
 Close #Lix
 
 On Error GoTo 0
 Exit Sub
errhandler:
Debug.Print err.description
    
 On Error GoTo 0
Close #Lix
Close #Lix2
End Sub

Sub Patch_file(File_Name_IN As String, File_Name_OUT As String, Boot_file As String, Optional offset As Single = 0)
Dim f1 As Long
Lix = FreeFile
Dim File_Name, boot As String
On Error GoTo errhandler

FileCopy File_Name_IN, File_Name_OUT

Open File_Name_OUT For Binary Access Write As #Lix
        
        Lix2 = FreeFile
       
        offset = offset + 1
        
        Open Boot_file For Binary Access Read As #Lix2
         boot = Space$(FileLen(Boot_file))
        Get #Lix2, offset, boot
        Close #Lix2
        
Put #Lix, , boot
 Close #Lix
 
 On Error GoTo 0
 Exit Sub
errhandler:
Show_error
Debug.Print err.description
    
 On Error GoTo 0
Close #Lix
Close #Lix2
End Sub


Function Get_QM_info(File_Name As String) As String

Dim offset As Integer
Dim Comment As String
Dim CopyQM_header As CopyQM_header


' ***********************************************************************************************
' *                                     CopyQM Header                                           *
' ***********************************************************************************************
  Dim clmhdr2 As ColumnHeader
  Dim Boot_info As bootstrap_Fat16
  Dim tmpchr As String
  Dim tmpval As Long
  Dim volume_info As Ms_Volume
  
    DskCenter.ListView_dos_header.ColumnHeaders.Clear
    '-----------------------------------------------------
    ' add columns to listview control
    '-----------------------------------------------------
    Set clmhdr2 = DskCenter.ListView_dos_header.ColumnHeaders.Add()
    clmhdr2.text = "CopyQM Properties:"
    clmhdr2.Width = 2 * (DskCenter.ListView_dos_header.Width / 3) - 530
         
    Set clmhdr2 = DskCenter.ListView_dos_header.ColumnHeaders.Add()
    clmhdr2.text = "Value:"
    clmhdr2.Width = (DskCenter.ListView_dos_header.Width / 3) + 200
    clmhdr2.Alignment = lvwColumnLeft
    
    'reset ListView_dos_header
    DskCenter.ListView_dos_header.ListItems.Clear
    
Lix = FreeFile

Open File_Name For Binary Access Read As #Lix
Get #Lix, 1, Msx_tag3
Get #Lix, 1, CopyQM_header
Close #Lix
Debug.Print CopyQM_header.Extra_disk
Debug.Print CopyQM_header.Comment_Lenght

offset = 136 + CInt(CopyQM_header.Comment_Lenght)


    DskCenter.ListView_dos_header.ListItems.Add , , "Volume Tag:"
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = Mid(Msx_tag3, 97, 10)
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).Bold = True

    DskCenter.ListView_dos_header.ListItems.Add , , "Comment (" & CopyQM_header.Comment_Lenght & "B):"
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = Mid(Msx_tag3, 134, CopyQM_header.Comment_Lenght)
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).Bold = True
    
  
   DskCenter.ListView_dos_header.ListItems.Add , , "Type:"
   DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).Bold = True
   
   If Mid(Msx_tag3, 29, 1) <> "0" Then
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = Mid(Msx_tag3, 29, 60)
      Else
      
      ' Disk type Format(&h62=720,&h30=160,&h74=1024,&h38=320).
      '180K, 360K, 720K, 1200K ,1440K , 1680K & 2880K
      
      Select Case CInt(CopyQM_header.Dsk_type)
      Case &H62 ' 720K
      DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = _
      "72" & Mid(Msx_tag3, 29, 60)
      
      Case &H30 '160K
      DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = _
      "16" & Mid(Msx_tag3, 29, 60)
      
      Case &H74 '1440K
      DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = _
      "1440" & Mid(Msx_tag3, 30, 59)
      
      Case &H38 '320K
      DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = _
      "32" & Mid(Msx_tag3, 29, 60)
      
      Case Else
      DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = Mid(Msx_tag3, 29, 60)
      
      End Select
      
   End If
   
    DskCenter.ListView_dos_header.ListItems.Add , , "Header Len:"
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = offset & " Bytes."
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).Bold = True
        
    DskCenter.ListView_dos_header.ListItems.Add , , "Sides:"
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = CInt(CopyQM_header.Sides)
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).Bold = True

    DskCenter.ListView_dos_header.ListItems.Add , , "Density:"
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).Bold = True
       If CInt(CopyQM_header.Info_density) = 0 Then
        If CInt(CopyQM_header.Sides) = 1 Then
           DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = "Low.(SSDD)"
           Else
           DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = "Low.(DSDD)"
        End If
       Else
        If CInt(CopyQM_header.Sides) = 1 Then
           DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = "Hight.(SSHD)"
           Else
           DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = "Hight.(DSHD)"
        End If
       
       End If
    
    DskCenter.ListView_dos_header.ListItems.Add , , "Sectors/Tracks:"
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = CInt(CopyQM_header.Sect_per_Track)
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).Bold = True
    
        
    DskCenter.ListView_dos_header.ListItems.Add , , "Cylinders:"
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = CInt(CopyQM_header.Cylinder_Side1)
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).Bold = True
        
    DskCenter.ListView_dos_header.ListItems.Add , , "Disk lenght:"
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).SubItems(1) = format$((CDbl(CopyQM_header.Cylinder_Side1) * CDbl(CopyQM_header.Sect_per_Track) * 512 * CDbl(CopyQM_header.Sides)) / 1000, "# ###.###") & " Kb."
    DskCenter.ListView_dos_header.ListItems(DskCenter.ListView_dos_header.ListItems.Count).Bold = True


End Function

Function CQM_offset(File_Name As String) As Integer
Dim Offset_comment As Byte

Lix = FreeFile
Open File_Name For Binary Access Read As #Lix
Get #Lix, 112, Offset_comment
CQM_offset = 136 + CInt(Offset_comment)
Close #Lix
End Function

Public Function Check_CRC32(Current_ZIPfile As String) As String
Dim myzip_CRC As New Unzip
Dim outpath As String

Current_ZipName = Current_ZIPfile
myzip_CRC.Verbose = 2
myzip_CRC.ExtractDir = outpath
myzip_CRC.Unzip Current_ZIPfile, Tmp_App_Path
Check_CRC32 = UCase(myzip_CRC.CRC_32)

End Function

Public Function Check_CRC32_file(File_Name As String) As String


  Dim cStream As New cBinaryFileStream
   cStream.File = File_Name
   
   Dim cCRC32 As New cCRC32
   Dim lCRC32 As Long

   lCRC32 = cCRC32.GetFileCrc32(cStream)
   
   Check_CRC32_file = Hex(lCRC32)

End Function
