Attribute VB_Name = "info_systems"
Option Explicit
'*****************************************
'*     INFO DISK MODULE - DskCenter      *
'*****************************************

' Check failed :
 Public Sub os_unknown(Nom_fichier As String)
 
 DskCenter.info_dsk_1.text = " Unknown format." & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text + Pc_Dsk_Format(Nom_fichier)
 
 End Sub

' Check C64 (CBM Dos) compatibilty: [D64]
 Public Sub os_info_C64(Nom_fichier As String)
 
 DskCenter.info_dsk_1.text = "Commodore C64 disk: D64" & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 
 End Sub

' Check TO8 compatibilty :
 Public Sub os_info_TO8(Nom_fichier As String)

 DskCenter.info_dsk_1.text = " TO7 & TO8 disk. " & vbCrLf & "Alexandre PUKALL format." & vbCrLf
' Header lenght fixed for 320kb disk, may change with sectors number.
' No boot-strap or header to fix disk lenght, We must add a count runtime to get lenght of header!
' ASCII header : 66b + 4b per sector.
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text + Pc_Dsk_Format(Nom_fichier, 7746)
 
 End Sub
 
 ' Check MO6 compatibilty :
 Public Sub os_info_MO6(Nom_fichier As String)

 DskCenter.info_dsk_1.text = " MO5 & MO6 disk. " & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text + Pc_Dsk_Format(Nom_fichier)
 
 End Sub
' Check Pc compatibilty :
 Public Sub os_info_dos(Nom_fichier As String)

 DskCenter.info_dsk_1.text = " Dos Boot sector " & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text + Pc_Dsk_Format(Nom_fichier)
 
 End Sub

' Check Pc compatibilty :
 Public Sub os_info_IBM(Nom_fichier As String)
 DskCenter.info_dsk_1.text = " IBM Boot sector " & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text + Pc_Dsk_Format(Nom_fichier)
 End Sub

' Check Pc compatibilty  Fat12:
 Public Sub os_info_Fat12(Nom_fichier As String)
 DskCenter.info_dsk_1.text = " Fat12 Boot sector " & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text + Pc_Dsk_Format(Nom_fichier)
 End Sub

' Check Pc compatibilty Fat16 :
 Public Sub os_info_Fat16(Nom_fichier As String)
 DskCenter.info_dsk_1.text = " Fat16 Boot sector " & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text + Pc_Dsk_Format(Nom_fichier)
 End Sub
    
' Check Pc compatibilty Microsoft DOS:
 Public Sub os_info_MS(Nom_fichier As String)
 DskCenter.info_dsk_1.text = " Microsoft Dos Boot sector " & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub
    
' Check Dos v2.5 compatibilty: [DSK;XFD;IMG==RAW]
 Public Sub os_info_dos25(Nom_fichier As String)
 DskCenter.info_dsk_1.text = "    Atari Dos 2.5 Boot [XFD]" & vbCrLf & "  or Ms Dos 2.x compatible." & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub
 
 ' Check Dos v2.5 compatibilty: [ATR]
 Public Sub os_info_dos25ATR(Nom_fichier As String)
 DskCenter.info_dsk_1.text = "    Atari Dos 2.5 Boot [ATR]" & vbCrLf & "  or Ms Dos 2.x compatible." & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier, 16)
 End Sub
    
  ' Check Amiga ADF compatibilty: [ADF]
 Public Sub os_info_AmigaADF(Nom_fichier As String)
  DskCenter.info_dsk_1.text = "  Commodore AMIGA file" & vbCrLf & "  [ADF disk image format]" & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub
   
 ' Check Amiga ADF compatibilty: [ADF] -Custom UAE-
 Public Sub os_info_AmigaADFCust(Nom_fichier As String)
 DskCenter.info_dsk_1.text = "Customed UAE AMIGA file" & vbCrLf & "  [ADF disk image format]" & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub
 
 ' Check Atari ST Dos compatibilty: [MSA]
 Public Sub os_info_AtariSTMSA(Nom_fichier As String)
 DskCenter.info_dsk_1.text = "    Atari ST Dos image file" & vbCrLf & "  [MSA disk image format]" & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier, 330)
 End Sub
 
  ' Check Atari ST compatibilty: [ST]
 Public Sub os_info_AtariST(Nom_fichier As String)
 DskCenter.info_dsk_1.text = "       Atari ST image file" & vbCrLf & "  [ST disk image format]" & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub
  
 ' Check Pc compatibilty Digital Research:
 Public Sub os_info_DR(Nom_fichier As String)
 DskCenter.info_dsk_1.text = " Digital Research" & vbCrLf & " Boot sector" & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub
 
 ' Check Linux compatibilty : (floppys)
 Public Sub os_info_Linux1(Nom_fichier As String)
 DskCenter.info_dsk_1.text = " Linux Bootstrap." & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub
 
  ' Check Linux compatibilty : (System)
 Public Sub os_info_Linux2(Nom_fichier As String)
 DskCenter.info_dsk_1.text = " Linux LILO Bootstrap." & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub
   ' Check Hard disk : (Dos bootstrap)
 Public Sub os_info_HD(Nom_fichier As String)
 DskCenter.info_dsk_1.text = " Hard disk - Dos Bootstrap -" & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub

 ' Check MSX compatibilty :
 Public Sub os_info_MSX(Nom_fichier As String)
 DskCenter.info_dsk_1.text = " MSX Boot sector" & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub

 ' Check TI99 compatibilty (old & Mess type ~V9T9~):
 Public Sub os_info_TI99(Nom_fichier As String)
 Select Case Computer
 Case "TI99-V9T9"
  DskCenter.info_dsk_1.text = " TI99 V9T9 disk" & vbCrLf
 Case "TI99-PC99PS"
  DskCenter.info_dsk_1.text = " TI99 PC99 SD disk" & vbCrLf
 Case "TI99-PC99PD"
  DskCenter.info_dsk_1.text = " TI99 PC99 DD disk" & vbCrLf
 Case "TI99-MESS"
  DskCenter.info_dsk_1.text = " TI99 Mess Hard Disk" & vbCrLf
 Case Else
  DskCenter.info_dsk_1.text = " TI99 #ERROR#" & vbCrLf
 End Select
 
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub
 
' Check CoCo DMK compatibilty :
 Public Sub os_info_CoCo(Nom_fichier As String)
 DskCenter.Label_Directory.Caption = "Directory:"
 DskCenter.info_dsk_1.text = " Color Computer DMK Disk. " & vbCrLf & "     TRS-80, Dragon 32/64" & vbCrLf & "            ( OS9 device )" & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub
 
 ' Check CoCo Tandi/TRS DOS compatibilty : (jvc)
 Public Sub os_info_CoCo2(Nom_fichier As String)
 DskCenter.info_dsk_1.text = " Color Computer JVC Disk." & vbCrLf & "     TRS-80, Dragon 32/64" & vbCrLf & "  (TRS or New DOS device)" & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub

 ' Check Oric / TDOS compatibilty : (MFM)
 Public Sub os_info_Oric(Nom_fichier As String)
 DskCenter.info_dsk_1.text = "  Oric & Pravetz 8D Disk." & vbCrLf & "     (TDos OS device)" & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub


' Check Mess system compatibilty :
 Public Sub os_info_Mess(Nom_fichier As String)
 TmpChar = get_mess_system(Nom_fichier)
 DskCenter.info_dsk_1.text = " Mess disk image device " & vbCrLf & TmpChar & vbCrLf
 
 End Sub
' Check CPM68k system compatibilty :
  Public Sub os_info_CPM68k(Nom_fichier As String)
 DskCenter.Label_Directory.Caption = "Directory: CP/m 68000."
 DskCenter.info_dsk_1.text = " CP/m 68000 OS boot." & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub

' Check CPM68k system compatibilty :
  Public Sub os_info_MSXCPM3(Nom_fichier As String)
 DskCenter.Label_Directory.Caption = "Directory: CP/m v3 for MSX."
 DskCenter.info_dsk_1.text = " MSX CP/m v.3 boot." & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub

' Check CPM86 system compatibilty :
  Public Sub os_info_CPM86(Nom_fichier As String)
 DskCenter.Label_Directory.Caption = "Directory: CP/m 86 for IBM."
 DskCenter.info_dsk_1.text = " CP/m 86 OS boot." & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub

' Check BBC system compatibilty :
  Public Sub os_info_BBC(Nom_fichier As String)
 DskCenter.Label_Directory.Caption = "Directory: BBC OS for BBC modelB."
 DskCenter.info_dsk_1.text = "   IMG, BBC or SSP format." & vbCrLf & "   For BBC micro model B." & vbCrLf
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub
' Check Maxidos/+ system compatibilty :
  Public Sub os_info_MaxiDos(Nom_fichier As String)
 DskCenter.Label_Directory.Caption = "Directory: MaxiDos."
   
 Select Case Computer
 ' Sad format.
 Case "MAXIDOSSAD"
  DskCenter.info_dsk_1.text = " MaxiDos .SAD disk format" & vbCrLf
 ' Sad format.
  Case "MAXIDOSDSK"
  DskCenter.info_dsk_1.text = " MaxiDos .DSK disk format" & vbCrLf
  End Select

 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub

' Check SamDos compatibilty :
  Public Sub os_info_SamDos(Nom_fichier As String)
 DskCenter.Label_Directory.Caption = "Directory: SamDos.(Sam Coupe')"

  
 Select Case Computer
 ' Sad format.
 Case "SAMDOSSAD"
  DskCenter.info_dsk_1.text = " SamDos OS boot." & vbCrLf
  DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & " .SAD disk format" & vbCrLf
 
 ' Dsk format.
 Case "SAMDOSDSK"
  DskCenter.info_dsk_1.text = " SamDos OS boot." & vbCrLf
  DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & " .DSK disk format" & vbCrLf
  
 ' Non DOS DSK format.
 Case "SAMDSK"
  DskCenter.info_dsk_1.text = " SamDos Format (?)." & vbCrLf & " Data Disk!" & vbCrLf
  DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & " .DSK disk format" & vbCrLf
 
 ' Non Dos Sad format.
 Case "SAMSAD"
  DskCenter.info_dsk_1.text = " SamDos format (?)." & vbCrLf & " Data Disk!" & vbCrLf
  DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & " .SAD disk format" & vbCrLf
    
  End Select

 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub
' Check B-Dos compatibilty : (Sinclair ZX Spectrum OS)
  Public Sub os_info_BDos(Nom_fichier As String)
  DskCenter.Label_Directory.Caption = "Directory: B-Dos.(ZX Spectrum)"
  DskCenter.info_dsk_1.text = " B-Dos OS boot." & vbCrLf
  DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & Pc_Dsk_Format(Nom_fichier)
 End Sub

' Check Mac system compatibilty :
  Public Sub os_info_Mac(Nom_fichier As String)
            ' Macintosh diskcopy header.
            LiX = FreeFile
            Dim Diskcopy_header_t As Diskcopy_header_t
                Open Nom_fichier For Binary Access Read As #LiX
                Get #LiX, 1, Diskcopy_header_t
                Close #1
                
Select Case Diskcopy_header_t.FormatByte
'  should be $00 Apple II, $01 Lisa, $02 Mac MFS ???
'  $12 = 400K, $22 = >400K Macintosh (DiskCopy uses this value for
'  all Apple II disks not 800K in size, and even for some of those),
'  $24 = 800K Apple II disk
Case 0
DskCenter.info_dsk_1.text = " Apple ][ Disk." & vbCrLf
Case 1
DskCenter.info_dsk_1.text = " Lisa Disk." & vbCrLf
Case 2
DskCenter.info_dsk_1.text = " Mac MFS Disk." & vbCrLf
Case &H12
DskCenter.info_dsk_1.text = " Apple ][ 400k Disk." & vbCrLf
Case &H22
DskCenter.info_dsk_1.text = " Mac >400k disk." & vbCrLf
Case &H24
DskCenter.info_dsk_1.text = " Apple ][ 800k Disk." & vbCrLf
Case Else
DskCenter.info_dsk_1.text = " May be an Apple Computer" & vbCrLf

End Select

Select Case Diskcopy_header_t.DiskFormat
'        0 = 400K, 1 = 800K, 2 = 720K, 3 = 1440K  (other values reserved)
Case 0
DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & "  400k image disk."
Case 1
DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & "  800k image disk."
Case 2
DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & "  720k image disk."
Case 3
DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & "  1440k image disk."
Case Else
DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & " Diskcopy Header corrupt!"
End Select

 
 DskCenter.info_dsk_1.text = DskCenter.info_dsk_1.text & vbCrLf & Pc_Dsk_Format(Nom_fichier)
 End Sub

         

Public Function Pc_Dsk_Format(File_Name As String, Optional Header_Offset As Single = 0) As String
Dim len_dsk As String
len_dsk = Int(FileLen(File_Name)) - Header_Offset

Select Case len_dsk

'Raw image disk
'Memory dump (Sna)
Case 1024
 Pc_Dsk_Format = " Memory dump (1k)"
Case 16384
 Pc_Dsk_Format = " Memory dump (16k)"
Case 32768
 Pc_Dsk_Format = " Memory dump (32k)"
Case 49179
 Pc_Dsk_Format = " Memory dump (48k)"
Case 65536
 Pc_Dsk_Format = " Memory dump (64k)"
 Case 131072
 Pc_Dsk_Format = " Memory dump(128k)"
  
'Disk dump (DSK or IMG)

' Atari floppy disks formats.
    
Case 80640
'35 * 18 * 1 * 128
Pc_Dsk_Format = "   35 Tracks SS/SD"

Case 92160
'SSSD 40 track TI 99/4A disk
'90 KB, 360 sectors: 9 sector/track, 40 tracks, 1 side.
Pc_Dsk_Format = "SSSD 40 track TI 99/4A"

Case 92928
'Bad sectors (+768 bytes)
'SSSD 40 track TI 99/4A disk
'90 KB, 360 sectors: 9 sector/track, 40 tracks, 1 side.
Pc_Dsk_Format = "SSSD 40 track TI 99/4A" & vbCrLf & "Bad sectors tagged"


Case 116480
'35 * 26 * 1 * 128
Pc_Dsk_Format = "   35 Tracks SS/MD"

Case 133120
'40 * 26 * 1 * 128
Pc_Dsk_Format = "   40 Tracks SS/MD"

Case 156672
'(34 * 9 * 256 ) 2 Sides (JVC - RS dos)
Pc_Dsk_Format = " 5'25 disk 34 Tracks (JVC)"

Case 160896
'(35 * 18 * 1 - 3) * 256 + 3 * 128
Pc_Dsk_Format = "   35 Tracks SS/DD"

Case 161280
'(35 * 9 * 256 ) 2 Sides (JVC - RS dos)
Pc_Dsk_Format = "   5'25 disk 35 Tracks  "

Case 163840
 Pc_Dsk_Format = " Floppy disk (160K)"

Case 174848
 Pc_Dsk_Format = "    VC1541 disk (170.75K)"

Case 177408
'77 * 18 * 1 * 128
Pc_Dsk_Format = "   77 Tracks SS/SD"

Case 183936
'(40 * 18 * 1 - 3) * 256 + 3 * 128
Pc_Dsk_Format = "   40 Tracks SS/DD"

Case 184320
'SSDD 40 track TI 99/4A disk
'180 KB, 720 sectors: 18 sector/track, 40 tracks, 1 side.
' or
'DSSD 40 track TI 99/4A disk
'180 KB, 360 sectors: 9 sector/track, 40 tracks, 2 sides.
Pc_Dsk_Format = "SSDD/DSSD 40 track TI 99/4A"

Case 224016
Pc_Dsk_Format = " 5'25 disk 34 Tracks (DMK)"

Case 256256
'77 * 26 * 1 * 128
Pc_Dsk_Format = "   77 Tracks SS/MD"
 
Case 266240
'40 * 18 * 2 * 128
Pc_Dsk_Format = "   40 Tracks DS/MD"

Case 281856
Pc_Dsk_Format = "   SEDORIC MFM TDOS"

Case 327680
 Pc_Dsk_Format = " Floppy disk (320K)"

Case 354432
'(77 * 18 * 1 - 3) * 256 + 3 * 128
Pc_Dsk_Format = "   77 SS/DD"

Case 354816
'77 * 18 * 2 * 128
Pc_Dsk_Format = "   77 Tracks DS/SD"

Case 368256
'(40 * 18 * 2 - 3) * 256 + 3 * 128
Pc_Dsk_Format = "   40 Tracks DS/DD"

Case 368640
'80 * 18 * 2 * 128
' or
'SSQD 80 track TI 99/4A disk
'360 KB, 1440 sectors: 18 sector/track, 80 tracks, 1 side.
'or
'DSDD 40 track TI 99/4A disk
'360 KB, 1440 sectors: 18 sector/track, 40 tracks, 2 sides.

Pc_Dsk_Format = "   DD 5.25' disk (360k)" & vbCrLf & "or 80 Tracks DS/SD" & vbCrLf & "SSQD 80 track TI 99/4A" & vbCrLf & "DSDD 40 track TI 99/4A"


Case 450560
  Pc_Dsk_Format = " SD 5.25' Amiga disk (440k)"

Case 512512
'77 * 26 * 2 * 128
Pc_Dsk_Format = "   77 Tracks DSMD"

Case 532480
'80 * 26 * 2 * 128
Pc_Dsk_Format = "   80 Tracks DSMD"

Case 537856
Pc_Dsk_Format = "   SEDORIC MFM TDOS"

Case 709248
'(77 * 18 * 2 - 3) * 256 + 3 * 128
Pc_Dsk_Format = "   77 Tracks DSDD"

Case 736896
'(80 * 18 * 2 - 3) * 256 + 3 * 128
Pc_Dsk_Format = "   80 Tracks DSDD"

Case 737280
'SSHD 80 track TI 99/4A 3.5" HD disk
'720 KB, 5760 sectors: 36 sector/track, 80 tracks, 1 side.
'or
'DSQD 80 track TI 99/4A disk
'720 KB, 1440 sectors: 18 sector/track, 80 tracks, 2 sides.
 
Pc_Dsk_Format = " DD 3.5' PC disk (720k) " & vbCrLf & "SSHD 80 track TI 99/4A 3.5'" & vbCrLf & "DSQD 80 track TI 99/4A"

' End disks formats.
Case 819200
 Pc_Dsk_Format = " 800kb DS 80 tracks," & vbCrLf & " 10 sectors,512 bytes."

Case 819222
 Pc_Dsk_Format = " 800kb DS 80 tracks," & vbCrLf & " 10 sectors,512 bytes." & vbCrLf & " Header=22B (.SAD)"
 
Case 901120
 Pc_Dsk_Format = " DD 3.5' Amiga disk (880k)"
 
Case 1474560

'DSHD 80 track TI 99/4A 3.5" HD disk
'1440 KB, 5760 sectors: 36 sector/track, 80 tracks, 2 sides.
 
 Pc_Dsk_Format = " DSHD 3.5' disk (1.44M)"

Case 1802240
  Pc_Dsk_Format = " HD 3.5' Amiga disk (1.76M)"


Case 1228800
 Pc_Dsk_Format = " HD 5.25' disk (1.20M)"
 
Case 2949120
 Pc_Dsk_Format = " HD 3.5' disk (2.88M)"
 

 
 
'------------------------------------------------------------------------
Case Else

If len_dsk < 6000000 Then Pc_Dsk_Format = " Bad floppy image format." Else Pc_Dsk_Format = " Hard disk image :"

End Select

If Header_Offset > 0 Then Pc_Dsk_Format = Pc_Dsk_Format & vbCrLf & "  Header :    " & Header_Offset & " bytes."

If len_dsk < 6000000 Then Pc_Dsk_Format = Pc_Dsk_Format & vbCrLf & " Real size: " & format(len_dsk, "  ###### 000 000") & " bytes"
If len_dsk > 6000000 Then Pc_Dsk_Format = Pc_Dsk_Format & vbCrLf & " Real size: " & format(len_dsk / 1000000, "  ###### 000 000") & " Mbytes"
 
Pc_Dsk_Format = Pc_Dsk_Format & vbCrLf & " CRC32: [ " & Check_CRC32_file(File_Name) & " ]"

End Function

